{-# LANGUAGE MagicHash #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}

module Curry_Inference (C_TypeEnv, d_C_inferProg, d_C_inferProgFromProgEnv, d_C_inferProgEnv, nd_C_inferProgEnv, d_C_inferFunction, d_C_inferFunctionEnv, nd_C_inferFunctionEnv, d_C_getTypeEnv, nd_C_getTypeEnv, d_C_getTypeEnvFromProgEnv, nd_C_getTypeEnvFromProgEnv) where

import Basics
import qualified Curry_AFCSubst
import qualified Curry_AnnotatedFlatCurry
import qualified Curry_AnnotatedFlatCurryGoodies
import qualified Curry_ErrorState
import qualified Curry_FiniteMap
import qualified Curry_FlatCurry
import qualified Curry_List
import qualified Curry_Prelude
import qualified Curry_Unification
import qualified Curry_UnificationSpec
type C_TypeEnv = Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr

type C_TIM t0 = Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))

type C_TypeEqs = Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)

type C_NormState = Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)

type C_NormStateM t0 = Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> ConstStore -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))

d_C_inferProg :: Curry_FlatCurry.C_Prog -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr))
d_C_inferProg x1 x3500 = Curry_Prelude.d_OP_gt_gt_eq (d_C_getTypeEnv x1 x3500) (d_OP_inferProg_dot___hash_lambda1 x1) x3500

d_OP_inferProg_dot___hash_lambda1 :: Curry_FlatCurry.C_Prog -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr))
d_OP_inferProg_dot___hash_lambda1 x1 x2 x3500 = Curry_Prelude.d_C_return (d_C_inferProgEnv x2 x1 x3500) x3500

nd_OP_inferProg_dot___hash_lambda1 :: Curry_FlatCurry.C_Prog -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr))
nd_OP_inferProg_dot___hash_lambda1 x1 x2 x3000 x3500 = let
     x2000 = x3000
      in (seq x2000 (Curry_Prelude.d_C_return (nd_C_inferProgEnv x2 x1 x2000 x3500) x3500))

d_C_inferProgFromProgEnv :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Curry_FlatCurry.C_Prog -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr)
d_C_inferProgFromProgEnv x1 x2 x3500 = d_OP__case_19 x2 x1 (d_C_getTypeEnvFromProgEnv x1 x2 x3500) x3500

d_C_inferProgEnv :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> Curry_FlatCurry.C_Prog -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr)
d_C_inferProgEnv x1 x2 x3500 = Curry_ErrorState.d_C_evalES (Curry_ErrorState.d_OP_gt_plus_eq (d_C_annProg x2 x3500) d_C_inferAProg) (d_C_initTIM x1 x3500) x3500

nd_C_inferProgEnv :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> Curry_FlatCurry.C_Prog -> IDSupply -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr)
nd_C_inferProgEnv x1 x2 x3000 x3500 = let
     x2003 = x3000
      in (seq x2003 (let
          x2002 = leftSupply x2003
          x2004 = rightSupply x2003
           in (seq x2002 (seq x2004 (let
               x2000 = leftSupply x2004
               x2001 = rightSupply x2004
                in (seq x2000 (seq x2001 (Curry_ErrorState.nd_C_evalES (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_annProg x2 x2000 x3500) (wrapNX id nd_C_inferAProg))) (nd_C_initTIM x1 x2001 x3500) x2002 x3500))))))))

d_C_inferFunction :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_FlatCurry.C_Prog -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr))
d_C_inferFunction x1 x2 x3500 = Curry_Prelude.d_OP_gt_gt_eq (d_C_getTypeEnv x2 x3500) (d_OP_inferFunction_dot___hash_lambda3 x1 x2) x3500

d_OP_inferFunction_dot___hash_lambda3 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_FlatCurry.C_Prog -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr))
d_OP_inferFunction_dot___hash_lambda3 x1 x2 x3 x3500 = Curry_Prelude.d_C_return (d_C_inferFunctionEnv x3 x1 x2 x3500) x3500

nd_OP_inferFunction_dot___hash_lambda3 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_FlatCurry.C_Prog -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr))
nd_OP_inferFunction_dot___hash_lambda3 x1 x2 x3 x3000 x3500 = let
     x2000 = x3000
      in (seq x2000 (Curry_Prelude.d_C_return (nd_C_inferFunctionEnv x3 x1 x2 x2000 x3500) x3500))

d_C_inferFunctionEnv :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_FlatCurry.C_Prog -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr)
d_C_inferFunctionEnv x1 x2 x3 x3500 = case x3 of
     (Curry_FlatCurry.C_Prog x4 x5 x6 x7 x8) -> d_OP__case_18 x7 x2 x1 (Curry_Prelude.d_C_apply (Curry_List.d_C_find (d_OP_inferFunctionEnv_dot_hasName_dot_20 x2) x3500) x7 x3500) x3500
     (Curry_FlatCurry.Choice_C_Prog x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_inferFunctionEnv x1 x2 x1002 x3500) (d_C_inferFunctionEnv x1 x2 x1003 x3500)
     (Curry_FlatCurry.Choices_C_Prog x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_inferFunctionEnv x1 x2 z x3500) x1002
     (Curry_FlatCurry.Guard_C_Prog x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_inferFunctionEnv x1 x2 x1002) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_Prog x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_C_inferFunctionEnv :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_FlatCurry.C_Prog -> IDSupply -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr)
nd_C_inferFunctionEnv x1 x2 x3 x3000 x3500 = case x3 of
     (Curry_FlatCurry.C_Prog x4 x5 x6 x7 x8) -> let
          x2004 = x3000
           in (seq x2004 (let
               x2003 = leftSupply x2004
               x2002 = rightSupply x2004
                in (seq x2003 (seq x2002 (nd_OP__case_18 x7 x2 x1 (let
                    x2001 = leftSupply x2002
                    x2000 = rightSupply x2002
                     in (seq x2001 (seq x2000 (Curry_Prelude.nd_C_apply (Curry_List.nd_C_find (wrapDX id (d_OP_inferFunctionEnv_dot_hasName_dot_20 x2)) x2000 x3500) x7 x2001 x3500)))) x2003 x3500)))))
     (Curry_FlatCurry.Choice_C_Prog x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_C_inferFunctionEnv x1 x2 x1002 x3000 x3500) (nd_C_inferFunctionEnv x1 x2 x1003 x3000 x3500)
     (Curry_FlatCurry.Choices_C_Prog x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_C_inferFunctionEnv x1 x2 z x3000 x3500) x1002
     (Curry_FlatCurry.Guard_C_Prog x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_C_inferFunctionEnv x1 x2 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_Prog x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP_inferFunctionEnv_dot_hasName_dot_20 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_FlatCurry.C_FuncDecl -> ConstStore -> Curry_Prelude.C_Bool
d_OP_inferFunctionEnv_dot_hasName_dot_20 x1 x2 x3500 = case x2 of
     (Curry_FlatCurry.C_Func x3 x4 x5 x6 x7) -> Curry_Prelude.d_OP_eq_eq x1 x3 x3500
     (Curry_FlatCurry.Choice_C_FuncDecl x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP_inferFunctionEnv_dot_hasName_dot_20 x1 x1002 x3500) (d_OP_inferFunctionEnv_dot_hasName_dot_20 x1 x1003 x3500)
     (Curry_FlatCurry.Choices_C_FuncDecl x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP_inferFunctionEnv_dot_hasName_dot_20 x1 z x3500) x1002
     (Curry_FlatCurry.Guard_C_FuncDecl x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP_inferFunctionEnv_dot_hasName_dot_20 x1 x1002) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_FuncDecl x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_lookupType :: ConstStore -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> ConstStore -> Curry_Prelude.C_Maybe Curry_FlatCurry.C_TypeExpr
d_C_lookupType x3500 = acceptCs id Curry_FiniteMap.d_C_lookupFM

nd_C_lookupType :: IDSupply -> ConstStore -> Func (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) (Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) (Curry_Prelude.C_Maybe Curry_FlatCurry.C_TypeExpr))
nd_C_lookupType x3000 x3500 = wrapDX (wrapNX id) (acceptCs id Curry_FiniteMap.nd_C_lookupFM)

d_C_getTypeEnv :: Curry_FlatCurry.C_Prog -> ConstStore -> Curry_Prelude.C_IO (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr)
d_C_getTypeEnv x1 x3500 = Curry_Prelude.d_OP_gt_gt_eq (d_C_extractImported x1 x3500) (d_OP_getTypeEnv_dot___hash_lambda5 x1) x3500

nd_C_getTypeEnv :: Curry_FlatCurry.C_Prog -> IDSupply -> ConstStore -> Curry_Prelude.C_IO (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr)
nd_C_getTypeEnv x1 x3000 x3500 = let
     x2000 = x3000
      in (seq x2000 (Curry_Prelude.nd_OP_gt_gt_eq (d_C_extractImported x1 x3500) (wrapNX id (nd_OP_getTypeEnv_dot___hash_lambda5 x1)) x2000 x3500))

d_OP_getTypeEnv_dot___hash_lambda5 :: Curry_FlatCurry.C_Prog -> Curry_Prelude.OP_List Curry_FlatCurry.C_Prog -> ConstStore -> Curry_Prelude.C_IO (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr)
d_OP_getTypeEnv_dot___hash_lambda5 x1 x2 x3500 = Curry_Prelude.d_C_return (d_C_extractKnownTypes (Curry_Prelude.OP_Cons x1 x2) x3500) x3500

nd_OP_getTypeEnv_dot___hash_lambda5 :: Curry_FlatCurry.C_Prog -> Curry_Prelude.OP_List Curry_FlatCurry.C_Prog -> IDSupply -> ConstStore -> Curry_Prelude.C_IO (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr)
nd_OP_getTypeEnv_dot___hash_lambda5 x1 x2 x3000 x3500 = let
     x2000 = x3000
      in (seq x2000 (Curry_Prelude.d_C_return (nd_C_extractKnownTypes (Curry_Prelude.OP_Cons x1 x2) x2000 x3500) x3500))

d_C_extractImported :: Curry_FlatCurry.C_Prog -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List Curry_FlatCurry.C_Prog)
d_C_extractImported x1 x3500 = case x1 of
     (Curry_FlatCurry.C_Prog x2 x3 x4 x5 x6) -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_mapIO Curry_FlatCurry.d_C_readFlatCurryInt x3500) x3 x3500
     (Curry_FlatCurry.Choice_C_Prog x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_extractImported x1002 x3500) (d_C_extractImported x1003 x3500)
     (Curry_FlatCurry.Choices_C_Prog x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_extractImported z x3500) x1002
     (Curry_FlatCurry.Guard_C_Prog x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_extractImported x1002) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_Prog x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_getTypeEnvFromProgEnv :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Curry_FlatCurry.C_Prog -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr)
d_C_getTypeEnvFromProgEnv x1 x2 x3500 = case x2 of
     (Curry_FlatCurry.C_Prog x3 x4 x5 x6 x7) -> d_OP__case_17 x4 x1 x2 (d_OP_getTypeEnvFromProgEnv_dot_extract_dot_47 x1 x4 x3500) x3500
     (Curry_FlatCurry.Choice_C_Prog x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_getTypeEnvFromProgEnv x1 x1002 x3500) (d_C_getTypeEnvFromProgEnv x1 x1003 x3500)
     (Curry_FlatCurry.Choices_C_Prog x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_getTypeEnvFromProgEnv x1 z x3500) x1002
     (Curry_FlatCurry.Guard_C_Prog x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_getTypeEnvFromProgEnv x1 x1002) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_Prog x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_C_getTypeEnvFromProgEnv :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Curry_FlatCurry.C_Prog -> IDSupply -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr)
nd_C_getTypeEnvFromProgEnv x1 x2 x3000 x3500 = case x2 of
     (Curry_FlatCurry.C_Prog x3 x4 x5 x6 x7) -> let
          x2000 = x3000
           in (seq x2000 (nd_OP__case_17 x4 x1 x2 (d_OP_getTypeEnvFromProgEnv_dot_extract_dot_47 x1 x4 x3500) x2000 x3500))
     (Curry_FlatCurry.Choice_C_Prog x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_C_getTypeEnvFromProgEnv x1 x1002 x3000 x3500) (nd_C_getTypeEnvFromProgEnv x1 x1003 x3000 x3500)
     (Curry_FlatCurry.Choices_C_Prog x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_C_getTypeEnvFromProgEnv x1 z x3000 x3500) x1002
     (Curry_FlatCurry.Guard_C_Prog x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_C_getTypeEnvFromProgEnv x1 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_Prog x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP_getTypeEnvFromProgEnv_dot_extract_dot_47 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_FlatCurry.C_Prog)
d_OP_getTypeEnvFromProgEnv_dot_extract_dot_47 x1 x2 x3500 = case x2 of
     Curry_Prelude.OP_List -> Curry_Prelude.C_Right Curry_Prelude.OP_List
     (Curry_Prelude.OP_Cons x3 x4) -> d_OP__case_16 x1 x3 x4 (Curry_Prelude.d_C_lookup x3 x1 x3500) x3500
     (Curry_Prelude.Choice_OP_List x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP_getTypeEnvFromProgEnv_dot_extract_dot_47 x1 x1002 x3500) (d_OP_getTypeEnvFromProgEnv_dot_extract_dot_47 x1 x1003 x3500)
     (Curry_Prelude.Choices_OP_List x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP_getTypeEnvFromProgEnv_dot_extract_dot_47 x1 z x3500) x1002
     (Curry_Prelude.Guard_OP_List x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP_getTypeEnvFromProgEnv_dot_extract_dot_47 x1 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_List x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_extractKnownTypes :: Curry_Prelude.OP_List Curry_FlatCurry.C_Prog -> ConstStore -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr
d_C_extractKnownTypes x1 x3500 = Curry_Prelude.d_C_apply (Curry_FiniteMap.d_C_listToFM (acceptCs id Curry_Prelude.d_OP_lt) x3500) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_concatMap d_OP_extractKnownTypes_dot_extractProg_dot_65 x3500) x1 x3500) x3500

nd_C_extractKnownTypes :: Curry_Prelude.OP_List Curry_FlatCurry.C_Prog -> IDSupply -> ConstStore -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr
nd_C_extractKnownTypes x1 x3000 x3500 = let
     x2005 = x3000
      in (seq x2005 (let
          x2004 = leftSupply x2005
          x2006 = rightSupply x2005
           in (seq x2004 (seq x2006 (let
               x2000 = leftSupply x2006
               x2003 = rightSupply x2006
                in (seq x2000 (seq x2003 (Curry_Prelude.nd_C_apply (Curry_FiniteMap.nd_C_listToFM (wrapDX (wrapDX id) (acceptCs id Curry_Prelude.d_OP_lt)) x2000 x3500) (let
                    x2002 = leftSupply x2003
                    x2001 = rightSupply x2003
                     in (seq x2002 (seq x2001 (Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_concatMap (wrapDX id d_OP_extractKnownTypes_dot_extractProg_dot_65) x2001 x3500) x1 x2002 x3500)))) x2004 x3500))))))))

d_OP_extractKnownTypes_dot_extractFuncDecl_dot_65 :: Curry_FlatCurry.C_FuncDecl -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr
d_OP_extractKnownTypes_dot_extractFuncDecl_dot_65 x1 x3500 = case x1 of
     (Curry_FlatCurry.C_Func x2 x3 x4 x5 x6) -> Curry_Prelude.OP_Tuple2 x2 x5
     (Curry_FlatCurry.Choice_C_FuncDecl x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP_extractKnownTypes_dot_extractFuncDecl_dot_65 x1002 x3500) (d_OP_extractKnownTypes_dot_extractFuncDecl_dot_65 x1003 x3500)
     (Curry_FlatCurry.Choices_C_FuncDecl x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP_extractKnownTypes_dot_extractFuncDecl_dot_65 z x3500) x1002
     (Curry_FlatCurry.Guard_C_FuncDecl x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP_extractKnownTypes_dot_extractFuncDecl_dot_65 x1002) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_FuncDecl x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP_extractKnownTypes_dot_extractConsDecl_dot_65 :: Curry_FlatCurry.C_TypeExpr -> Curry_FlatCurry.C_ConsDecl -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr
d_OP_extractKnownTypes_dot_extractConsDecl_dot_65 x1 x2 x3500 = case x2 of
     (Curry_FlatCurry.C_Cons x3 x4 x5 x6) -> Curry_Prelude.OP_Tuple2 x3 (Curry_Prelude.d_C_foldr (acceptCs (acceptCs id) Curry_FlatCurry.C_FuncType) x1 x6 x3500)
     (Curry_FlatCurry.Choice_C_ConsDecl x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP_extractKnownTypes_dot_extractConsDecl_dot_65 x1 x1002 x3500) (d_OP_extractKnownTypes_dot_extractConsDecl_dot_65 x1 x1003 x3500)
     (Curry_FlatCurry.Choices_C_ConsDecl x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP_extractKnownTypes_dot_extractConsDecl_dot_65 x1 z x3500) x1002
     (Curry_FlatCurry.Guard_C_ConsDecl x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP_extractKnownTypes_dot_extractConsDecl_dot_65 x1 x1002) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_ConsDecl x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP_extractKnownTypes_dot_extractTypeDecl_dot_65 :: Curry_FlatCurry.C_TypeDecl -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr)
d_OP_extractKnownTypes_dot_extractTypeDecl_dot_65 x1 x3500 = case x1 of
     (Curry_FlatCurry.C_TypeSyn x2 x3 x4 x5) -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x2 x5) Curry_Prelude.OP_List
     (Curry_FlatCurry.C_Type x6 x7 x8 x9) -> let
          x10 = Curry_FlatCurry.C_TCons x6 (Curry_Prelude.d_C_map (acceptCs id Curry_FlatCurry.C_TVar) x8 x3500)
           in (Curry_Prelude.d_C_map (d_OP_extractKnownTypes_dot_extractConsDecl_dot_65 x10) x9 x3500)
     (Curry_FlatCurry.Choice_C_TypeDecl x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP_extractKnownTypes_dot_extractTypeDecl_dot_65 x1002 x3500) (d_OP_extractKnownTypes_dot_extractTypeDecl_dot_65 x1003 x3500)
     (Curry_FlatCurry.Choices_C_TypeDecl x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP_extractKnownTypes_dot_extractTypeDecl_dot_65 z x3500) x1002
     (Curry_FlatCurry.Guard_C_TypeDecl x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP_extractKnownTypes_dot_extractTypeDecl_dot_65 x1002) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_TypeDecl x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP_extractKnownTypes_dot_extractProg_dot_65 :: Curry_FlatCurry.C_Prog -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr)
d_OP_extractKnownTypes_dot_extractProg_dot_65 x1 x3500 = case x1 of
     (Curry_FlatCurry.C_Prog x2 x3 x4 x5 x6) -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_concatMap d_OP_extractKnownTypes_dot_extractTypeDecl_dot_65 x3500) x4 x3500) (Curry_Prelude.d_C_map d_OP_extractKnownTypes_dot_extractFuncDecl_dot_65 x5 x3500) x3500
     (Curry_FlatCurry.Choice_C_Prog x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP_extractKnownTypes_dot_extractProg_dot_65 x1002 x3500) (d_OP_extractKnownTypes_dot_extractProg_dot_65 x1003 x3500)
     (Curry_FlatCurry.Choices_C_Prog x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP_extractKnownTypes_dot_extractProg_dot_65 z x3500) x1002
     (Curry_FlatCurry.Guard_C_Prog x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP_extractKnownTypes_dot_extractProg_dot_65 x1002) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_Prog x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_initTIM :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)
d_C_initTIM x1 x3500 = Curry_Prelude.OP_Tuple3 x1 (Curry_Prelude.C_Int 0#) (Curry_FiniteMap.d_C_emptyFM (acceptCs id Curry_Prelude.d_OP_lt) x3500)

nd_C_initTIM :: Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)
nd_C_initTIM x1 x3000 x3500 = let
     x2000 = x3000
      in (seq x2000 (Curry_Prelude.OP_Tuple3 x1 (Curry_Prelude.C_Int 0#) (Curry_FiniteMap.nd_C_emptyFM (wrapDX (wrapDX id) (acceptCs id Curry_Prelude.d_OP_lt)) x2000 x3500)))

d_C_nextTVar :: ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_nextTVar x3500 = Curry_ErrorState.d_OP_gt_plus_eq Curry_ErrorState.d_C_gets d_OP_nextTVar_dot___hash_lambda9

nd_C_nextTVar :: IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_nextTVar x3000 x3500 = wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (wrapDX id Curry_ErrorState.d_C_gets) (wrapNX id nd_OP_nextTVar_dot___hash_lambda9))

d_OP_nextTVar_dot___hash_lambda9 :: Curry_Prelude.Curry t0 => Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP_nextTVar_dot___hash_lambda9 x1 x3500 = case x1 of
     (Curry_Prelude.OP_Tuple3 x2 x3 x4) -> Curry_ErrorState.d_OP_gt_plus (Curry_ErrorState.d_C_puts (Curry_Prelude.OP_Tuple3 x2 (Curry_Prelude.d_OP_plus x3 (Curry_Prelude.C_Int 1#) x3500) x4)) (Curry_ErrorState.d_C_returnES (Curry_FlatCurry.C_TVar x3)) x3500
     (Curry_Prelude.Choice_OP_Tuple3 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP_nextTVar_dot___hash_lambda9 x1002 x3500) (d_OP_nextTVar_dot___hash_lambda9 x1003 x3500)
     (Curry_Prelude.Choices_OP_Tuple3 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP_nextTVar_dot___hash_lambda9 z x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple3 x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP_nextTVar_dot___hash_lambda9 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple3 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_OP_nextTVar_dot___hash_lambda9 :: Curry_Prelude.Curry t0 => Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP_nextTVar_dot___hash_lambda9 x1 x3000 x3500 = case x1 of
     (Curry_Prelude.OP_Tuple3 x2 x3 x4) -> let
          x2000 = x3000
           in (seq x2000 (Curry_ErrorState.nd_OP_gt_plus (wrapDX id (Curry_ErrorState.d_C_puts (Curry_Prelude.OP_Tuple3 x2 (Curry_Prelude.d_OP_plus x3 (Curry_Prelude.C_Int 1#) x3500) x4))) (wrapDX id (Curry_ErrorState.d_C_returnES (Curry_FlatCurry.C_TVar x3))) x2000 x3500))
     (Curry_Prelude.Choice_OP_Tuple3 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_OP_nextTVar_dot___hash_lambda9 x1002 x3000 x3500) (nd_OP_nextTVar_dot___hash_lambda9 x1003 x3000 x3500)
     (Curry_Prelude.Choices_OP_Tuple3 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_OP_nextTVar_dot___hash_lambda9 z x3000 x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple3 x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_OP_nextTVar_dot___hash_lambda9 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple3 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_initVar2TVar :: ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_initVar2TVar x3500 = Curry_Prelude.d_OP_dollar (acceptCs id Curry_ErrorState.d_C_modify) d_OP_initVar2TVar_dot___hash_lambda10 x3500

nd_C_initVar2TVar :: IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_initVar2TVar x3000 x3500 = let
     x2000 = x3000
      in (seq x2000 (Curry_Prelude.nd_OP_dollar (wrapDX (wrapNX id) (acceptCs id Curry_ErrorState.nd_C_modify)) (wrapNX id nd_OP_initVar2TVar_dot___hash_lambda10) x2000 x3500))

d_OP_initVar2TVar_dot___hash_lambda10 :: (Curry_Prelude.Curry t0,Curry_Prelude.Curry t1) => Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM t0 t1)
d_OP_initVar2TVar_dot___hash_lambda10 x1 x3500 = case x1 of
     (Curry_Prelude.OP_Tuple3 x2 x3 x4) -> Curry_Prelude.OP_Tuple3 x2 x3 (Curry_FiniteMap.d_C_emptyFM (acceptCs id Curry_Prelude.d_OP_lt) x3500)
     (Curry_Prelude.Choice_OP_Tuple3 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP_initVar2TVar_dot___hash_lambda10 x1002 x3500) (d_OP_initVar2TVar_dot___hash_lambda10 x1003 x3500)
     (Curry_Prelude.Choices_OP_Tuple3 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP_initVar2TVar_dot___hash_lambda10 z x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple3 x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP_initVar2TVar_dot___hash_lambda10 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple3 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_OP_initVar2TVar_dot___hash_lambda10 :: (Curry_Prelude.Curry t0,Curry_Prelude.Curry t1) => Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> IDSupply -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM t0 t1)
nd_OP_initVar2TVar_dot___hash_lambda10 x1 x3000 x3500 = case x1 of
     (Curry_Prelude.OP_Tuple3 x2 x3 x4) -> let
          x2000 = x3000
           in (seq x2000 (Curry_Prelude.OP_Tuple3 x2 x3 (Curry_FiniteMap.nd_C_emptyFM (wrapDX (wrapDX id) (acceptCs id Curry_Prelude.d_OP_lt)) x2000 x3500)))
     (Curry_Prelude.Choice_OP_Tuple3 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_OP_initVar2TVar_dot___hash_lambda10 x1002 x3000 x3500) (nd_OP_initVar2TVar_dot___hash_lambda10 x1003 x3000 x3500)
     (Curry_Prelude.Choices_OP_Tuple3 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_OP_initVar2TVar_dot___hash_lambda10 z x3000 x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple3 x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_OP_initVar2TVar_dot___hash_lambda10 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple3 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_insertVar2TVar :: Curry_Prelude.C_Int -> Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_insertVar2TVar x1 x2 x3500 = Curry_Prelude.d_OP_dollar (acceptCs id Curry_ErrorState.d_C_modify) (d_OP_insertVar2TVar_dot___hash_lambda11 x2 x1) x3500

nd_C_insertVar2TVar :: Curry_Prelude.C_Int -> Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_insertVar2TVar x1 x2 x3000 x3500 = let
     x2000 = x3000
      in (seq x2000 (Curry_Prelude.nd_OP_dollar (wrapDX (wrapNX id) (acceptCs id Curry_ErrorState.nd_C_modify)) (wrapNX id (nd_OP_insertVar2TVar_dot___hash_lambda11 x2 x1)) x2000 x3500))

d_OP_insertVar2TVar_dot___hash_lambda11 :: Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)
d_OP_insertVar2TVar_dot___hash_lambda11 x1 x2 x3 x3500 = case x3 of
     (Curry_Prelude.OP_Tuple3 x4 x5 x6) -> Curry_Prelude.OP_Tuple3 x4 x5 (Curry_FiniteMap.d_C_addToFM x6 x2 x1 x3500)
     (Curry_Prelude.Choice_OP_Tuple3 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP_insertVar2TVar_dot___hash_lambda11 x1 x2 x1002 x3500) (d_OP_insertVar2TVar_dot___hash_lambda11 x1 x2 x1003 x3500)
     (Curry_Prelude.Choices_OP_Tuple3 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP_insertVar2TVar_dot___hash_lambda11 x1 x2 z x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple3 x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP_insertVar2TVar_dot___hash_lambda11 x1 x2 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple3 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_OP_insertVar2TVar_dot___hash_lambda11 :: Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> IDSupply -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)
nd_OP_insertVar2TVar_dot___hash_lambda11 x1 x2 x3 x3000 x3500 = case x3 of
     (Curry_Prelude.OP_Tuple3 x4 x5 x6) -> let
          x2000 = x3000
           in (seq x2000 (Curry_Prelude.OP_Tuple3 x4 x5 (Curry_FiniteMap.nd_C_addToFM x6 x2 x1 x2000 x3500)))
     (Curry_Prelude.Choice_OP_Tuple3 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_OP_insertVar2TVar_dot___hash_lambda11 x1 x2 x1002 x3000 x3500) (nd_OP_insertVar2TVar_dot___hash_lambda11 x1 x2 x1003 x3000 x3500)
     (Curry_Prelude.Choices_OP_Tuple3 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_OP_insertVar2TVar_dot___hash_lambda11 x1 x2 z x3000 x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple3 x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_OP_insertVar2TVar_dot___hash_lambda11 x1 x2 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple3 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_insertFreshVar :: Curry_Prelude.C_Int -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_insertFreshVar x1 x3500 = Curry_ErrorState.d_OP_gt_plus_eq (d_C_nextTVar x3500) (d_C_insertVar2TVar x1)

nd_C_insertFreshVar :: Curry_Prelude.C_Int -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_insertFreshVar x1 x3000 x3500 = let
     x2000 = x3000
      in (seq x2000 (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_nextTVar x2000 x3500) (wrapNX id (nd_C_insertVar2TVar x1)))))

d_C_lookupVar2TVar :: Curry_Prelude.C_Int -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Maybe Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_lookupVar2TVar x1 x3500 = Curry_ErrorState.d_OP_gt_plus_eq Curry_ErrorState.d_C_gets (d_OP_lookupVar2TVar_dot___hash_lambda12 x1)

nd_C_lookupVar2TVar :: Curry_Prelude.C_Int -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Maybe Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_lookupVar2TVar x1 x3000 x3500 = wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (wrapDX id Curry_ErrorState.d_C_gets) (wrapNX id (nd_OP_lookupVar2TVar_dot___hash_lambda12 x1)))

d_OP_lookupVar2TVar_dot___hash_lambda12 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> t0 -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Maybe Curry_FlatCurry.C_TypeExpr) t0)
d_OP_lookupVar2TVar_dot___hash_lambda12 x1 x2 x3500 = case x2 of
     (Curry_Prelude.OP_Tuple3 x3 x4 x5) -> Curry_ErrorState.d_C_returnES (Curry_FiniteMap.d_C_lookupFM x5 x1 x3500)
     (Curry_Prelude.Choice_OP_Tuple3 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP_lookupVar2TVar_dot___hash_lambda12 x1 x1002 x3500) (d_OP_lookupVar2TVar_dot___hash_lambda12 x1 x1003 x3500)
     (Curry_Prelude.Choices_OP_Tuple3 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP_lookupVar2TVar_dot___hash_lambda12 x1 z x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple3 x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP_lookupVar2TVar_dot___hash_lambda12 x1 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple3 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_OP_lookupVar2TVar_dot___hash_lambda12 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> IDSupply -> ConstStore -> Func t0 (Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Maybe Curry_FlatCurry.C_TypeExpr) t0))
nd_OP_lookupVar2TVar_dot___hash_lambda12 x1 x2 x3000 x3500 = case x2 of
     (Curry_Prelude.OP_Tuple3 x3 x4 x5) -> let
          x2000 = x3000
           in (seq x2000 (wrapDX id (Curry_ErrorState.d_C_returnES (Curry_FiniteMap.nd_C_lookupFM x5 x1 x2000 x3500))))
     (Curry_Prelude.Choice_OP_Tuple3 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_OP_lookupVar2TVar_dot___hash_lambda12 x1 x1002 x3000 x3500) (nd_OP_lookupVar2TVar_dot___hash_lambda12 x1 x1003 x3000 x3500)
     (Curry_Prelude.Choices_OP_Tuple3 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_OP_lookupVar2TVar_dot___hash_lambda12 x1 z x3000 x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple3 x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_OP_lookupVar2TVar_dot___hash_lambda12 x1 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple3 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_getTypeVariant :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_getTypeVariant x1 x3500 = Curry_ErrorState.d_OP_gt_plus_eq Curry_ErrorState.d_C_gets (d_OP_getTypeVariant_dot___hash_lambda13 x1)

nd_C_getTypeVariant :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_getTypeVariant x1 x3000 x3500 = wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (wrapDX id Curry_ErrorState.d_C_gets) (wrapNX id (nd_OP_getTypeVariant_dot___hash_lambda13 x1)))

d_OP_getTypeVariant_dot___hash_lambda13 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP_getTypeVariant_dot___hash_lambda13 x1 x2 x3500 = case x2 of
     (Curry_Prelude.OP_Tuple3 x3 x4 x5) -> d_OP__case_14 x1 x3 (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_C_lookupType x3500) x3 x3500) x1 x3500) x3500
     (Curry_Prelude.Choice_OP_Tuple3 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP_getTypeVariant_dot___hash_lambda13 x1 x1002 x3500) (d_OP_getTypeVariant_dot___hash_lambda13 x1 x1003 x3500)
     (Curry_Prelude.Choices_OP_Tuple3 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP_getTypeVariant_dot___hash_lambda13 x1 z x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple3 x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP_getTypeVariant_dot___hash_lambda13 x1 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple3 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_OP_getTypeVariant_dot___hash_lambda13 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP_getTypeVariant_dot___hash_lambda13 x1 x2 x3000 x3500 = case x2 of
     (Curry_Prelude.OP_Tuple3 x3 x4 x5) -> let
          x2006 = x3000
           in (seq x2006 (let
               x2005 = leftSupply x2006
               x2004 = rightSupply x2006
                in (seq x2005 (seq x2004 (nd_OP__case_14 x1 x3 (let
                    x2003 = leftSupply x2004
                    x2002 = rightSupply x2004
                     in (seq x2003 (seq x2002 (Curry_Prelude.nd_C_apply (let
                         x2001 = leftSupply x2002
                         x2000 = rightSupply x2002
                          in (seq x2001 (seq x2000 (Curry_Prelude.nd_C_apply (nd_C_lookupType x2000 x3500) x3 x2001 x3500)))) x1 x2003 x3500)))) x2005 x3500)))))
     (Curry_Prelude.Choice_OP_Tuple3 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_OP_getTypeVariant_dot___hash_lambda13 x1 x1002 x3000 x3500) (nd_OP_getTypeVariant_dot___hash_lambda13 x1 x1003 x3000 x3500)
     (Curry_Prelude.Choices_OP_Tuple3 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_OP_getTypeVariant_dot___hash_lambda13 x1 z x3000 x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple3 x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_OP_getTypeVariant_dot___hash_lambda13 x1 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple3 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP_getTypeVariant_dot___hash_lambda13_dot___hash_lambda15 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_FlatCurry.C_TypeExpr -> ConstStore -> t0 -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) t0)
d_OP_getTypeVariant_dot___hash_lambda13_dot___hash_lambda15 x1 x2 x3500 = Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 x1 x2)

nd_OP_getTypeVariant_dot___hash_lambda13_dot___hash_lambda15 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func t0 (Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) t0))
nd_OP_getTypeVariant_dot___hash_lambda13_dot___hash_lambda15 x1 x2 x3000 x3500 = wrapDX id (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 x1 x2))

d_C_freshVariant :: Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_freshVariant x1 x3500 = Curry_ErrorState.d_C_liftES Curry_Prelude.d_C_snd (d_OP_freshVariant_dot_rename_dot_120 Curry_Prelude.OP_List x1 x3500) x3500

nd_C_freshVariant :: Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_freshVariant x1 x3000 x3500 = let
     x2002 = x3000
      in (seq x2002 (let
          x2001 = leftSupply x2002
          x2000 = rightSupply x2002
           in (seq x2001 (seq x2000 (Curry_ErrorState.nd_C_liftES (wrapDX id Curry_Prelude.d_C_snd) (nd_OP_freshVariant_dot_rename_dot_120 Curry_Prelude.OP_List x1 x2000 x3500) x2001 x3500)))))

d_OP_freshVariant_dot_rename_dot_120 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP_freshVariant_dot_rename_dot_120 x1 x2 x3500 = case x2 of
     (Curry_FlatCurry.C_TVar x3) -> d_OP__case_13 x1 x3 (Curry_Prelude.d_C_lookup x3 x1 x3500) x3500
     (Curry_FlatCurry.C_FuncType x5 x6) -> Curry_ErrorState.d_OP_gt_plus_eq (d_OP_freshVariant_dot_rename_dot_120 x1 x5 x3500) (d_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18 x6)
     (Curry_FlatCurry.C_TCons x7 x8) -> Curry_ErrorState.d_OP_gt_plus_eq (Curry_ErrorState.d_C_mapAccumES (acceptCs id d_OP_freshVariant_dot_rename_dot_120) x1 x8 x3500) (d_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda20 x7)
     (Curry_FlatCurry.Choice_C_TypeExpr x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP_freshVariant_dot_rename_dot_120 x1 x1002 x3500) (d_OP_freshVariant_dot_rename_dot_120 x1 x1003 x3500)
     (Curry_FlatCurry.Choices_C_TypeExpr x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP_freshVariant_dot_rename_dot_120 x1 z x3500) x1002
     (Curry_FlatCurry.Guard_C_TypeExpr x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP_freshVariant_dot_rename_dot_120 x1 x1002) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_TypeExpr x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_OP_freshVariant_dot_rename_dot_120 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP_freshVariant_dot_rename_dot_120 x1 x2 x3000 x3500 = case x2 of
     (Curry_FlatCurry.C_TVar x3) -> let
          x2000 = x3000
           in (seq x2000 (nd_OP__case_13 x1 x3 (Curry_Prelude.d_C_lookup x3 x1 x3500) x2000 x3500))
     (Curry_FlatCurry.C_FuncType x5 x6) -> let
          x2000 = x3000
           in (seq x2000 (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_OP_freshVariant_dot_rename_dot_120 x1 x5 x2000 x3500) (wrapNX id (nd_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18 x6)))))
     (Curry_FlatCurry.C_TCons x7 x8) -> let
          x2000 = x3000
           in (seq x2000 (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (Curry_ErrorState.nd_C_mapAccumES (wrapDX (wrapNX id) (acceptCs id nd_OP_freshVariant_dot_rename_dot_120)) x1 x8 x2000 x3500) (wrapNX id (nd_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda20 x7)))))
     (Curry_FlatCurry.Choice_C_TypeExpr x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_OP_freshVariant_dot_rename_dot_120 x1 x1002 x3000 x3500) (nd_OP_freshVariant_dot_rename_dot_120 x1 x1003 x3000 x3500)
     (Curry_FlatCurry.Choices_C_TypeExpr x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_OP_freshVariant_dot_rename_dot_120 x1 z x3000 x3500) x1002
     (Curry_FlatCurry.Guard_C_TypeExpr x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_OP_freshVariant_dot_rename_dot_120 x1 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_TypeExpr x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda17 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_Prelude.C_Int -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_FlatCurry.C_TypeExpr -> ConstStore -> t0 -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr) t0)
d_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda17 x1 x2 x3 x3500 = Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x1 x3) x2) x3)

nd_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda17 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_Prelude.C_Int -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func t0 (Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr) t0))
nd_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda17 x1 x2 x3 x3000 x3500 = wrapDX id (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x1 x3) x2) x3))

d_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18 :: Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18 x1 x2 x3500 = case x2 of
     (Curry_Prelude.OP_Tuple2 x3 x4) -> Curry_ErrorState.d_OP_gt_plus_eq (d_OP_freshVariant_dot_rename_dot_120 x3 x1 x3500) (d_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18_dot___hash_lambda19 x4)
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18 x1 x1002 x3500) (d_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18 x1 x1003 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18 x1 z x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18 x1 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple2 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18 :: Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18 x1 x2 x3000 x3500 = case x2 of
     (Curry_Prelude.OP_Tuple2 x3 x4) -> let
          x2000 = x3000
           in (seq x2000 (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_OP_freshVariant_dot_rename_dot_120 x3 x1 x2000 x3500) (wrapNX id (nd_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18_dot___hash_lambda19 x4)))))
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18 x1 x1002 x3000 x3500) (nd_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18 x1 x1003 x3000 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18 x1 z x3000 x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18 x1 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple2 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18_dot___hash_lambda19 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr -> ConstStore -> t0 -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr) t0)
d_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18_dot___hash_lambda19 x1 x2 x3500 = case x2 of
     (Curry_Prelude.OP_Tuple2 x3 x4) -> Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 x3 (Curry_FlatCurry.C_FuncType x1 x4))
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18_dot___hash_lambda19 x1 x1002 x3500) (d_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18_dot___hash_lambda19 x1 x1003 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18_dot___hash_lambda19 x1 z x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18_dot___hash_lambda19 x1 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple2 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18_dot___hash_lambda19 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func t0 (Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr) t0))
nd_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18_dot___hash_lambda19 x1 x2 x3000 x3500 = case x2 of
     (Curry_Prelude.OP_Tuple2 x3 x4) -> wrapDX id (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 x3 (Curry_FlatCurry.C_FuncType x1 x4)))
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18_dot___hash_lambda19 x1 x1002 x3000 x3500) (nd_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18_dot___hash_lambda19 x1 x1003 x3000 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18_dot___hash_lambda19 x1 z x3000 x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda18_dot___hash_lambda19 x1 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple2 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda20 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_List Curry_FlatCurry.C_TypeExpr) -> ConstStore -> t0 -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr) t0)
d_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda20 x1 x2 x3500 = case x2 of
     (Curry_Prelude.OP_Tuple2 x3 x4) -> Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 x3 (Curry_FlatCurry.C_TCons x1 x4))
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda20 x1 x1002 x3500) (d_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda20 x1 x1003 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda20 x1 z x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda20 x1 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple2 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda20 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_List Curry_FlatCurry.C_TypeExpr) -> IDSupply -> ConstStore -> Func t0 (Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr) t0))
nd_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda20 x1 x2 x3000 x3500 = case x2 of
     (Curry_Prelude.OP_Tuple2 x3 x4) -> wrapDX id (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 x3 (Curry_FlatCurry.C_TCons x1 x4)))
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda20 x1 x1002 x3000 x3500) (nd_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda20 x1 x1003 x3000 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda20 x1 z x3000 x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda20 x1 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple2 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP_plus_plus_eq :: Curry_Prelude.Curry t0 => ConstStore -> (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))) -> ConstStore -> (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))) -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP_plus_plus_eq x3500 = acceptCs id (Curry_ErrorState.d_C_liftES2 (acceptCs id Curry_Prelude.d_OP_plus_plus))

nd_OP_plus_plus_eq :: Curry_Prelude.Curry t0 => IDSupply -> ConstStore -> Func (Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))) (Func (Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))) (Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))))
nd_OP_plus_plus_eq x3000 x3500 = wrapDX (wrapNX id) (acceptCs id (Curry_ErrorState.nd_C_liftES2 (wrapDX (wrapDX id) (acceptCs id Curry_Prelude.d_OP_plus_plus))))

d_C_annProg :: Curry_FlatCurry.C_Prog -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_annProg x1 x3500 = case x1 of
     (Curry_FlatCurry.C_Prog x2 x3 x4 x5 x6) -> Curry_ErrorState.d_C_liftES (d_OP_annProg_dot___hash_lambda21 x3 x2 x6 x4) (Curry_ErrorState.d_C_mapES d_C_annFunc x5 x3500) x3500
     (Curry_FlatCurry.Choice_C_Prog x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_annProg x1002 x3500) (d_C_annProg x1003 x3500)
     (Curry_FlatCurry.Choices_C_Prog x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_annProg z x3500) x1002
     (Curry_FlatCurry.Guard_C_Prog x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_annProg x1002) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_Prog x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_C_annProg :: Curry_FlatCurry.C_Prog -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_annProg x1 x3000 x3500 = case x1 of
     (Curry_FlatCurry.C_Prog x2 x3 x4 x5 x6) -> let
          x2002 = x3000
           in (seq x2002 (let
               x2001 = leftSupply x2002
               x2000 = rightSupply x2002
                in (seq x2001 (seq x2000 (Curry_ErrorState.nd_C_liftES (wrapDX id (d_OP_annProg_dot___hash_lambda21 x3 x2 x6 x4)) (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_annFunc) x5 x2000 x3500) x2001 x3500)))))
     (Curry_FlatCurry.Choice_C_Prog x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_C_annProg x1002 x3000 x3500) (nd_C_annProg x1003 x3000 x3500)
     (Curry_FlatCurry.Choices_C_Prog x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_C_annProg z x3000 x3500) x1002
     (Curry_FlatCurry.Guard_C_Prog x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_C_annProg x1002 x3000) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_Prog x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP_annProg_dot___hash_lambda21 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_FlatCurry.C_OpDecl -> Curry_Prelude.OP_List Curry_FlatCurry.C_TypeDecl -> Curry_Prelude.OP_List (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr
d_OP_annProg_dot___hash_lambda21 x1 x2 x3 x4 x5 x3500 = Curry_AnnotatedFlatCurry.C_AProg x2 x1 x4 x5 x3

d_C_annFunc :: Curry_FlatCurry.C_FuncDecl -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_annFunc x1 x3500 = case x1 of
     (Curry_FlatCurry.C_Func x2 x3 x4 x5 x6) -> Curry_ErrorState.d_OP_gt_plus (d_C_initVar2TVar x3500) (Curry_ErrorState.d_C_liftES2 (acceptCs (acceptCs id) (Curry_AnnotatedFlatCurry.C_AFunc x2 x3 x4)) (d_C_freshVariant x5 x3500) (d_C_annRule x6 x3500) x3500) x3500
     (Curry_FlatCurry.Choice_C_FuncDecl x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_annFunc x1002 x3500) (d_C_annFunc x1003 x3500)
     (Curry_FlatCurry.Choices_C_FuncDecl x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_annFunc z x3500) x1002
     (Curry_FlatCurry.Guard_C_FuncDecl x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_annFunc x1002) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_FuncDecl x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_C_annFunc :: Curry_FlatCurry.C_FuncDecl -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_annFunc x1 x3000 x3500 = case x1 of
     (Curry_FlatCurry.C_Func x2 x3 x4 x5 x6) -> let
          x2007 = x3000
           in (seq x2007 (let
               x2006 = leftSupply x2007
               x2008 = rightSupply x2007
                in (seq x2006 (seq x2008 (let
                    x2000 = leftSupply x2008
                    x2004 = rightSupply x2008
                     in (seq x2000 (seq x2004 (Curry_ErrorState.nd_OP_gt_plus (nd_C_initVar2TVar x2000 x3500) (let
                         x2003 = leftSupply x2004
                         x2005 = rightSupply x2004
                          in (seq x2003 (seq x2005 (let
                              x2001 = leftSupply x2005
                              x2002 = rightSupply x2005
                               in (seq x2001 (seq x2002 (Curry_ErrorState.nd_C_liftES2 (wrapDX (wrapDX id) (acceptCs (acceptCs id) (Curry_AnnotatedFlatCurry.C_AFunc x2 x3 x4))) (nd_C_freshVariant x5 x2001 x3500) (nd_C_annRule x6 x2002 x3500) x2003 x3500))))))) x2006 x3500))))))))
     (Curry_FlatCurry.Choice_C_FuncDecl x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_C_annFunc x1002 x3000 x3500) (nd_C_annFunc x1003 x3000 x3500)
     (Curry_FlatCurry.Choices_C_FuncDecl x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_C_annFunc z x3000 x3500) x1002
     (Curry_FlatCurry.Guard_C_FuncDecl x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_C_annFunc x1002 x3000) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_FuncDecl x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_annRule :: Curry_FlatCurry.C_Rule -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_ARule Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_annRule x1 x3500 = case x1 of
     (Curry_FlatCurry.C_Rule x2 x3) -> Curry_ErrorState.d_C_liftES3 (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_ARule) (d_C_nextTVar x3500) (Curry_ErrorState.d_C_mapES d_C_annVar x2 x3500) (d_C_annExpr x3 x3500) x3500
     (Curry_FlatCurry.C_External x4) -> Curry_ErrorState.d_C_liftES (d_OP_annRule_dot___hash_lambda22 x4) (d_C_nextTVar x3500) x3500
     (Curry_FlatCurry.Choice_C_Rule x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_annRule x1002 x3500) (d_C_annRule x1003 x3500)
     (Curry_FlatCurry.Choices_C_Rule x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_annRule z x3500) x1002
     (Curry_FlatCurry.Guard_C_Rule x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_annRule x1002) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_Rule x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_C_annRule :: Curry_FlatCurry.C_Rule -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_ARule Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_annRule x1 x3000 x3500 = case x1 of
     (Curry_FlatCurry.C_Rule x2 x3) -> let
          x2004 = x3000
           in (seq x2004 (let
               x2005 = leftSupply x2004
               x2006 = rightSupply x2004
                in (seq x2005 (seq x2006 (let
                    x2003 = leftSupply x2005
                    x2000 = rightSupply x2005
                     in (seq x2003 (seq x2000 (let
                         x2001 = leftSupply x2006
                         x2002 = rightSupply x2006
                          in (seq x2001 (seq x2002 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_ARule)) (nd_C_nextTVar x2000 x3500) (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_annVar) x2 x2001 x3500) (nd_C_annExpr x3 x2002 x3500) x2003 x3500)))))))))))
     (Curry_FlatCurry.C_External x4) -> let
          x2002 = x3000
           in (seq x2002 (let
               x2001 = leftSupply x2002
               x2000 = rightSupply x2002
                in (seq x2001 (seq x2000 (Curry_ErrorState.nd_C_liftES (wrapDX id (d_OP_annRule_dot___hash_lambda22 x4)) (nd_C_nextTVar x2000 x3500) x2001 x3500)))))
     (Curry_FlatCurry.Choice_C_Rule x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_C_annRule x1002 x3000 x3500) (nd_C_annRule x1003 x3000 x3500)
     (Curry_FlatCurry.Choices_C_Rule x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_C_annRule z x3000 x3500) x1002
     (Curry_FlatCurry.Guard_C_Rule x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_C_annRule x1002 x3000) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_Rule x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP_annRule_dot___hash_lambda22 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_AnnotatedFlatCurry.C_ARule Curry_FlatCurry.C_TypeExpr
d_OP_annRule_dot___hash_lambda22 x1 x2 x3500 = Curry_AnnotatedFlatCurry.C_AExternal x2 x1

d_C_annExpr :: Curry_FlatCurry.C_Expr -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_annExpr x1 x3500 = case x1 of
     (Curry_FlatCurry.C_Var x2) -> let
          x3 = Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'V'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'b'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List))))))))) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_show x2 x3500) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'z'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'w'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'y'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'p'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '!'#) Curry_Prelude.OP_List))))))))))))))))))))))))))))) x3500) x3500
           in (Curry_ErrorState.d_OP_gt_plus_eq (d_C_lookupVar2TVar x2 x3500) (Curry_Prelude.d_C_maybe (Curry_ErrorState.d_C_failES x3) (d_OP_annExpr_dot___hash_lambda23 x2)))
     (Curry_FlatCurry.C_Lit x4) -> Curry_ErrorState.d_OP_gt_plus_eq (d_C_nextTVar x3500) (d_OP_annExpr_dot___hash_lambda24 x4)
     (Curry_FlatCurry.C_Comb x5 x6 x7) -> Curry_ErrorState.d_C_liftES3 (d_OP_annExpr_dot___hash_lambda25 x5) (d_C_nextTVar x3500) (d_C_getTypeVariant x6 x3500) (Curry_ErrorState.d_C_mapES d_C_annExpr x7 x3500) x3500
     (Curry_FlatCurry.C_Case x8 x9 x10) -> Curry_ErrorState.d_C_liftES3 (d_OP_annExpr_dot___hash_lambda26 x8) (d_C_nextTVar x3500) (d_C_annExpr x9 x3500) (Curry_ErrorState.d_C_mapES d_C_annBranch x10 x3500) x3500
     (Curry_FlatCurry.C_Or x11 x12) -> Curry_ErrorState.d_C_liftES3 (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_AOr) (d_C_nextTVar x3500) (d_C_annExpr x11 x3500) (d_C_annExpr x12 x3500) x3500
     (Curry_FlatCurry.C_Let x13 x14) -> Curry_ErrorState.d_C_liftES3 (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_ALet) (d_C_nextTVar x3500) (d_OP_annExpr_dot_annBindings_dot_163 x13 x3500) (d_C_annExpr x14 x3500) x3500
     (Curry_FlatCurry.C_Free x15 x16) -> Curry_ErrorState.d_C_liftES3 (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_AFree) (d_C_nextTVar x3500) (Curry_ErrorState.d_C_mapES d_OP_annExpr_dot_annFree_dot_173 x15 x3500) (d_C_annExpr x16 x3500) x3500
     (Curry_FlatCurry.C_Typed x17 x18) -> Curry_ErrorState.d_C_liftES3 (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_ATyped) (d_C_nextTVar x3500) (d_C_annExpr x17 x3500) (d_C_freshVariant x18 x3500) x3500
     (Curry_FlatCurry.Choice_C_Expr x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_annExpr x1002 x3500) (d_C_annExpr x1003 x3500)
     (Curry_FlatCurry.Choices_C_Expr x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_annExpr z x3500) x1002
     (Curry_FlatCurry.Guard_C_Expr x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_annExpr x1002) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_Expr x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_C_annExpr :: Curry_FlatCurry.C_Expr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_annExpr x1 x3000 x3500 = case x1 of
     (Curry_FlatCurry.C_Var x2) -> let
          x2000 = x3000
           in (seq x2000 (let
               x3 = Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'V'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'b'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List))))))))) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_show x2 x3500) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'z'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'w'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'y'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'p'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '!'#) Curry_Prelude.OP_List))))))))))))))))))))))))))))) x3500) x3500
                in (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_lookupVar2TVar x2 x2000 x3500) (wrapNX id (Curry_Prelude.nd_C_maybe (wrapDX id (Curry_ErrorState.d_C_failES x3)) (wrapNX id (nd_OP_annExpr_dot___hash_lambda23 x2))))))))
     (Curry_FlatCurry.C_Lit x4) -> let
          x2000 = x3000
           in (seq x2000 (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_nextTVar x2000 x3500) (wrapNX id (nd_OP_annExpr_dot___hash_lambda24 x4)))))
     (Curry_FlatCurry.C_Comb x5 x6 x7) -> let
          x2004 = x3000
           in (seq x2004 (let
               x2005 = leftSupply x2004
               x2006 = rightSupply x2004
                in (seq x2005 (seq x2006 (let
                    x2003 = leftSupply x2005
                    x2000 = rightSupply x2005
                     in (seq x2003 (seq x2000 (let
                         x2001 = leftSupply x2006
                         x2002 = rightSupply x2006
                          in (seq x2001 (seq x2002 (Curry_ErrorState.nd_C_liftES3 (wrapNX id (nd_OP_annExpr_dot___hash_lambda25 x5)) (nd_C_nextTVar x2000 x3500) (nd_C_getTypeVariant x6 x2001 x3500) (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_annExpr) x7 x2002 x3500) x2003 x3500)))))))))))
     (Curry_FlatCurry.C_Case x8 x9 x10) -> let
          x2004 = x3000
           in (seq x2004 (let
               x2005 = leftSupply x2004
               x2006 = rightSupply x2004
                in (seq x2005 (seq x2006 (let
                    x2003 = leftSupply x2005
                    x2000 = rightSupply x2005
                     in (seq x2003 (seq x2000 (let
                         x2001 = leftSupply x2006
                         x2002 = rightSupply x2006
                          in (seq x2001 (seq x2002 (Curry_ErrorState.nd_C_liftES3 (wrapNX id (nd_OP_annExpr_dot___hash_lambda26 x8)) (nd_C_nextTVar x2000 x3500) (nd_C_annExpr x9 x2001 x3500) (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_annBranch) x10 x2002 x3500) x2003 x3500)))))))))))
     (Curry_FlatCurry.C_Or x11 x12) -> let
          x2004 = x3000
           in (seq x2004 (let
               x2005 = leftSupply x2004
               x2006 = rightSupply x2004
                in (seq x2005 (seq x2006 (let
                    x2003 = leftSupply x2005
                    x2000 = rightSupply x2005
                     in (seq x2003 (seq x2000 (let
                         x2001 = leftSupply x2006
                         x2002 = rightSupply x2006
                          in (seq x2001 (seq x2002 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_AOr)) (nd_C_nextTVar x2000 x3500) (nd_C_annExpr x11 x2001 x3500) (nd_C_annExpr x12 x2002 x3500) x2003 x3500)))))))))))
     (Curry_FlatCurry.C_Let x13 x14) -> let
          x2004 = x3000
           in (seq x2004 (let
               x2005 = leftSupply x2004
               x2006 = rightSupply x2004
                in (seq x2005 (seq x2006 (let
                    x2003 = leftSupply x2005
                    x2000 = rightSupply x2005
                     in (seq x2003 (seq x2000 (let
                         x2001 = leftSupply x2006
                         x2002 = rightSupply x2006
                          in (seq x2001 (seq x2002 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_ALet)) (nd_C_nextTVar x2000 x3500) (nd_OP_annExpr_dot_annBindings_dot_163 x13 x2001 x3500) (nd_C_annExpr x14 x2002 x3500) x2003 x3500)))))))))))
     (Curry_FlatCurry.C_Free x15 x16) -> let
          x2004 = x3000
           in (seq x2004 (let
               x2005 = leftSupply x2004
               x2006 = rightSupply x2004
                in (seq x2005 (seq x2006 (let
                    x2003 = leftSupply x2005
                    x2000 = rightSupply x2005
                     in (seq x2003 (seq x2000 (let
                         x2001 = leftSupply x2006
                         x2002 = rightSupply x2006
                          in (seq x2001 (seq x2002 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_AFree)) (nd_C_nextTVar x2000 x3500) (Curry_ErrorState.nd_C_mapES (wrapNX id nd_OP_annExpr_dot_annFree_dot_173) x15 x2001 x3500) (nd_C_annExpr x16 x2002 x3500) x2003 x3500)))))))))))
     (Curry_FlatCurry.C_Typed x17 x18) -> let
          x2004 = x3000
           in (seq x2004 (let
               x2005 = leftSupply x2004
               x2006 = rightSupply x2004
                in (seq x2005 (seq x2006 (let
                    x2003 = leftSupply x2005
                    x2000 = rightSupply x2005
                     in (seq x2003 (seq x2000 (let
                         x2001 = leftSupply x2006
                         x2002 = rightSupply x2006
                          in (seq x2001 (seq x2002 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_ATyped)) (nd_C_nextTVar x2000 x3500) (nd_C_annExpr x17 x2001 x3500) (nd_C_freshVariant x18 x2002 x3500) x2003 x3500)))))))))))
     (Curry_FlatCurry.Choice_C_Expr x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_C_annExpr x1002 x3000 x3500) (nd_C_annExpr x1003 x3000 x3500)
     (Curry_FlatCurry.Choices_C_Expr x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_C_annExpr z x3000 x3500) x1002
     (Curry_FlatCurry.Guard_C_Expr x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_C_annExpr x1002 x3000) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_Expr x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP_annExpr_dot___hash_lambda23 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_Prelude.C_Int -> Curry_FlatCurry.C_TypeExpr -> ConstStore -> t0 -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) t0)
d_OP_annExpr_dot___hash_lambda23 x1 x2 x3500 = Curry_ErrorState.d_C_returnES (Curry_AnnotatedFlatCurry.C_AVar x2 x1)

nd_OP_annExpr_dot___hash_lambda23 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_Prelude.C_Int -> Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func t0 (Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) t0))
nd_OP_annExpr_dot___hash_lambda23 x1 x2 x3000 x3500 = wrapDX id (Curry_ErrorState.d_C_returnES (Curry_AnnotatedFlatCurry.C_AVar x2 x1))

d_OP_annExpr_dot___hash_lambda24 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_FlatCurry.C_Literal -> Curry_FlatCurry.C_TypeExpr -> ConstStore -> t0 -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) t0)
d_OP_annExpr_dot___hash_lambda24 x1 x2 x3500 = Curry_ErrorState.d_C_returnES (Curry_AnnotatedFlatCurry.C_ALit x2 x1)

nd_OP_annExpr_dot___hash_lambda24 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_FlatCurry.C_Literal -> Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func t0 (Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) t0))
nd_OP_annExpr_dot___hash_lambda24 x1 x2 x3000 x3500 = wrapDX id (Curry_ErrorState.d_C_returnES (Curry_AnnotatedFlatCurry.C_ALit x2 x1))

d_OP_annExpr_dot___hash_lambda25 :: Curry_FlatCurry.C_CombType -> Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_List (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr
d_OP_annExpr_dot___hash_lambda25 x1 x2 x3500 = acceptCs (acceptCs id) (Curry_AnnotatedFlatCurry.C_AComb x2 x1)

nd_OP_annExpr_dot___hash_lambda25 :: Curry_FlatCurry.C_CombType -> Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) (Func (Curry_Prelude.OP_List (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr)) (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr))
nd_OP_annExpr_dot___hash_lambda25 x1 x2 x3000 x3500 = wrapDX (wrapDX id) (acceptCs (acceptCs id) (Curry_AnnotatedFlatCurry.C_AComb x2 x1))

d_OP_annExpr_dot___hash_lambda26 :: Curry_FlatCurry.C_CaseType -> Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_List (Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr
d_OP_annExpr_dot___hash_lambda26 x1 x2 x3500 = acceptCs (acceptCs id) (Curry_AnnotatedFlatCurry.C_ACase x2 x1)

nd_OP_annExpr_dot___hash_lambda26 :: Curry_FlatCurry.C_CaseType -> Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) (Func (Curry_Prelude.OP_List (Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr)) (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr))
nd_OP_annExpr_dot___hash_lambda26 x1 x2 x3000 x3500 = wrapDX (wrapDX id) (acceptCs (acceptCs id) (Curry_AnnotatedFlatCurry.C_ACase x2 x1))

d_OP_annExpr_dot_checkVar_dot_163 :: Curry_Prelude.C_Int -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP_annExpr_dot_checkVar_dot_163 x1 x3500 = Curry_ErrorState.d_OP_gt_plus (Curry_ErrorState.d_OP_gt_plus (d_C_checkShadowing x1 x3500) (d_C_insertFreshVar x1 x3500) x3500) (Curry_ErrorState.d_C_returnES x1) x3500

nd_OP_annExpr_dot_checkVar_dot_163 :: Curry_Prelude.C_Int -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP_annExpr_dot_checkVar_dot_163 x1 x3000 x3500 = let
     x2006 = x3000
      in (seq x2006 (let
          x2005 = leftSupply x2006
          x2003 = rightSupply x2006
           in (seq x2005 (seq x2003 (Curry_ErrorState.nd_OP_gt_plus (let
               x2002 = leftSupply x2003
               x2004 = rightSupply x2003
                in (seq x2002 (seq x2004 (let
                    x2000 = leftSupply x2004
                    x2001 = rightSupply x2004
                     in (seq x2000 (seq x2001 (Curry_ErrorState.nd_OP_gt_plus (nd_C_checkShadowing x1 x2000 x3500) (nd_C_insertFreshVar x1 x2001 x3500) x2002 x3500))))))) (wrapDX id (Curry_ErrorState.d_C_returnES x1)) x2005 x3500)))))

d_OP_annExpr_dot_annBindings_dot_163 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_Expr) -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr))) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP_annExpr_dot_annBindings_dot_163 x1 x3500 = let
     x2 = Curry_Prelude.d_C_unzip x1 x3500
     x3 = d_OP_annExpr_dot_annBindings_dot_163_dot___hash_selFP2_hash_vs x2 x3500
     x4 = d_OP_annExpr_dot_annBindings_dot_163_dot___hash_selFP3_hash_es x2 x3500
      in (Curry_ErrorState.d_OP_gt_plus_eq (Curry_ErrorState.d_C_mapES d_OP_annExpr_dot_checkVar_dot_163 x3 x3500) (d_OP_annExpr_dot_annBindings_dot_163_dot___hash_lambda27 x4))

nd_OP_annExpr_dot_annBindings_dot_163 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_Expr) -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr))) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP_annExpr_dot_annBindings_dot_163 x1 x3000 x3500 = let
     x2000 = x3000
      in (seq x2000 (let
          x2 = Curry_Prelude.d_C_unzip x1 x3500
          x3 = d_OP_annExpr_dot_annBindings_dot_163_dot___hash_selFP2_hash_vs x2 x3500
          x4 = d_OP_annExpr_dot_annBindings_dot_163_dot___hash_selFP3_hash_es x2 x3500
           in (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (Curry_ErrorState.nd_C_mapES (wrapNX id nd_OP_annExpr_dot_checkVar_dot_163) x3 x2000 x3500) (wrapNX id (nd_OP_annExpr_dot_annBindings_dot_163_dot___hash_lambda27 x4))))))

d_OP_annExpr_dot_annBindings_dot_163_dot___hash_selFP2_hash_vs :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Int) (Curry_Prelude.OP_List Curry_FlatCurry.C_Expr) -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Int
d_OP_annExpr_dot_annBindings_dot_163_dot___hash_selFP2_hash_vs x1 x3500 = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> x2
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP_annExpr_dot_annBindings_dot_163_dot___hash_selFP2_hash_vs x1002 x3500) (d_OP_annExpr_dot_annBindings_dot_163_dot___hash_selFP2_hash_vs x1003 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP_annExpr_dot_annBindings_dot_163_dot___hash_selFP2_hash_vs z x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP_annExpr_dot_annBindings_dot_163_dot___hash_selFP2_hash_vs x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple2 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP_annExpr_dot_annBindings_dot_163_dot___hash_selFP3_hash_es :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Int) (Curry_Prelude.OP_List Curry_FlatCurry.C_Expr) -> ConstStore -> Curry_Prelude.OP_List Curry_FlatCurry.C_Expr
d_OP_annExpr_dot_annBindings_dot_163_dot___hash_selFP3_hash_es x1 x3500 = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> x3
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP_annExpr_dot_annBindings_dot_163_dot___hash_selFP3_hash_es x1002 x3500) (d_OP_annExpr_dot_annBindings_dot_163_dot___hash_selFP3_hash_es x1003 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP_annExpr_dot_annBindings_dot_163_dot___hash_selFP3_hash_es z x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP_annExpr_dot_annBindings_dot_163_dot___hash_selFP3_hash_es x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple2 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP_annExpr_dot_annBindings_dot_163_dot___hash_lambda27 :: Curry_Prelude.OP_List Curry_FlatCurry.C_Expr -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr))) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP_annExpr_dot_annBindings_dot_163_dot___hash_lambda27 x1 x2 x3500 = Curry_ErrorState.d_OP_gt_plus_eq (Curry_ErrorState.d_C_mapES d_C_annExpr x1 x3500) (d_OP_annExpr_dot_annBindings_dot_163_dot___hash_lambda27_dot___hash_lambda28 x2)

nd_OP_annExpr_dot_annBindings_dot_163_dot___hash_lambda27 :: Curry_Prelude.OP_List Curry_FlatCurry.C_Expr -> Curry_Prelude.OP_List Curry_Prelude.C_Int -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr))) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP_annExpr_dot_annBindings_dot_163_dot___hash_lambda27 x1 x2 x3000 x3500 = let
     x2000 = x3000
      in (seq x2000 (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_annExpr) x1 x2000 x3500) (wrapNX id (nd_OP_annExpr_dot_annBindings_dot_163_dot___hash_lambda27_dot___hash_lambda28 x2)))))

d_OP_annExpr_dot_annBindings_dot_163_dot___hash_lambda27_dot___hash_lambda28 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_Prelude.OP_List Curry_Prelude.C_Int -> Curry_Prelude.OP_List (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) -> ConstStore -> t0 -> ConstStore -> Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr))) t0)
d_OP_annExpr_dot_annBindings_dot_163_dot___hash_lambda27_dot___hash_lambda28 x1 x2 x3500 = Curry_ErrorState.d_C_returnES (Curry_Prelude.d_C_zip x1 x2 x3500)

nd_OP_annExpr_dot_annBindings_dot_163_dot___hash_lambda27_dot___hash_lambda28 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_Prelude.OP_List Curry_Prelude.C_Int -> Curry_Prelude.OP_List (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) -> IDSupply -> ConstStore -> Func t0 (Curry_Prelude.C_Either t1 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr))) t0))
nd_OP_annExpr_dot_annBindings_dot_163_dot___hash_lambda27_dot___hash_lambda28 x1 x2 x3000 x3500 = wrapDX id (Curry_ErrorState.d_C_returnES (Curry_Prelude.d_C_zip x1 x2 x3500))

d_OP_annExpr_dot_annFree_dot_173 :: Curry_Prelude.C_Int -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP_annExpr_dot_annFree_dot_173 x1 x3500 = Curry_ErrorState.d_OP_gt_plus (d_C_checkShadowing x1 x3500) (d_C_annVar x1 x3500) x3500

nd_OP_annExpr_dot_annFree_dot_173 :: Curry_Prelude.C_Int -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP_annExpr_dot_annFree_dot_173 x1 x3000 x3500 = let
     x2003 = x3000
      in (seq x2003 (let
          x2002 = leftSupply x2003
          x2004 = rightSupply x2003
           in (seq x2002 (seq x2004 (let
               x2000 = leftSupply x2004
               x2001 = rightSupply x2004
                in (seq x2000 (seq x2001 (Curry_ErrorState.nd_OP_gt_plus (nd_C_checkShadowing x1 x2000 x3500) (nd_C_annVar x1 x2001 x3500) x2002 x3500))))))))

d_C_annVar :: Curry_Prelude.C_Int -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_annVar x1 x3500 = Curry_ErrorState.d_OP_gt_plus_eq (d_C_nextTVar x3500) (d_OP_annVar_dot___hash_lambda29 x1)

nd_C_annVar :: Curry_Prelude.C_Int -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_annVar x1 x3000 x3500 = let
     x2000 = x3000
      in (seq x2000 (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_nextTVar x2000 x3500) (wrapNX id (nd_OP_annVar_dot___hash_lambda29 x1)))))

d_OP_annVar_dot___hash_lambda29 :: Curry_Prelude.C_Int -> Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP_annVar_dot___hash_lambda29 x1 x2 x3500 = Curry_ErrorState.d_OP_gt_plus (d_C_insertVar2TVar x1 x2 x3500) (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 x1 x2)) x3500

nd_OP_annVar_dot___hash_lambda29 :: Curry_Prelude.C_Int -> Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP_annVar_dot___hash_lambda29 x1 x2 x3000 x3500 = let
     x2002 = x3000
      in (seq x2002 (let
          x2001 = leftSupply x2002
          x2000 = rightSupply x2002
           in (seq x2001 (seq x2000 (Curry_ErrorState.nd_OP_gt_plus (nd_C_insertVar2TVar x1 x2 x2000 x3500) (wrapDX id (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 x1 x2))) x2001 x3500)))))

d_C_checkShadowing :: Curry_Prelude.C_Int -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_checkShadowing x1 x3500 = let
     x2 = Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 's'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'w'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'g'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'w'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'v'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'b'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List)))))))))))))))))))))))) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_show x1 x3500) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '!'#) Curry_Prelude.OP_List)))))))))) x3500) x3500
      in (Curry_ErrorState.d_OP_gt_plus_eq (d_C_lookupVar2TVar x1 x3500) (Curry_Prelude.d_C_maybe (Curry_ErrorState.d_C_returnES Curry_Prelude.OP_Unit) (d_OP_checkShadowing_dot___hash_lambda30 x2)))

nd_C_checkShadowing :: Curry_Prelude.C_Int -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_checkShadowing x1 x3000 x3500 = let
     x2000 = x3000
      in (seq x2000 (let
          x2 = Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 's'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'w'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'g'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'w'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'v'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'b'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List)))))))))))))))))))))))) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_show x1 x3500) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '!'#) Curry_Prelude.OP_List)))))))))) x3500) x3500
           in (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_lookupVar2TVar x1 x2000 x3500) (wrapNX id (Curry_Prelude.nd_C_maybe (wrapDX id (Curry_ErrorState.d_C_returnES Curry_Prelude.OP_Unit)) (wrapNX id (nd_OP_checkShadowing_dot___hash_lambda30 x2))))))))

d_OP_checkShadowing_dot___hash_lambda30 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_FlatCurry.C_TypeExpr -> ConstStore -> t0 -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 t1 t0)
d_OP_checkShadowing_dot___hash_lambda30 x1 x2 x3500 = Curry_ErrorState.d_C_failES x1

nd_OP_checkShadowing_dot___hash_lambda30 :: (Curry_Prelude.Curry t1,Curry_Prelude.Curry t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func t0 (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 t1 t0))
nd_OP_checkShadowing_dot___hash_lambda30 x1 x2 x3000 x3500 = wrapDX id (Curry_ErrorState.d_C_failES x1)

d_C_annBranch :: Curry_FlatCurry.C_BranchExpr -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_annBranch x1 x3500 = case x1 of
     (Curry_FlatCurry.C_Branch x2 x3) -> Curry_ErrorState.d_C_liftES2 (acceptCs (acceptCs id) Curry_AnnotatedFlatCurry.C_ABranch) (d_C_annPattern x2 x3500) (d_C_annExpr x3 x3500) x3500
     (Curry_FlatCurry.Choice_C_BranchExpr x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_annBranch x1002 x3500) (d_C_annBranch x1003 x3500)
     (Curry_FlatCurry.Choices_C_BranchExpr x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_annBranch z x3500) x1002
     (Curry_FlatCurry.Guard_C_BranchExpr x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_annBranch x1002) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_BranchExpr x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_C_annBranch :: Curry_FlatCurry.C_BranchExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_annBranch x1 x3000 x3500 = case x1 of
     (Curry_FlatCurry.C_Branch x2 x3) -> let
          x2003 = x3000
           in (seq x2003 (let
               x2002 = leftSupply x2003
               x2004 = rightSupply x2003
                in (seq x2002 (seq x2004 (let
                    x2000 = leftSupply x2004
                    x2001 = rightSupply x2004
                     in (seq x2000 (seq x2001 (Curry_ErrorState.nd_C_liftES2 (wrapDX (wrapDX id) (acceptCs (acceptCs id) Curry_AnnotatedFlatCurry.C_ABranch)) (nd_C_annPattern x2 x2000 x3500) (nd_C_annExpr x3 x2001 x3500) x2002 x3500))))))))
     (Curry_FlatCurry.Choice_C_BranchExpr x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_C_annBranch x1002 x3000 x3500) (nd_C_annBranch x1003 x3000 x3500)
     (Curry_FlatCurry.Choices_C_BranchExpr x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_C_annBranch z x3000 x3500) x1002
     (Curry_FlatCurry.Guard_C_BranchExpr x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_C_annBranch x1002 x3000) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_BranchExpr x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_annPattern :: Curry_FlatCurry.C_Pattern -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_APattern Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_annPattern x1 x3500 = case x1 of
     (Curry_FlatCurry.C_Pattern x2 x3) -> Curry_ErrorState.d_C_liftES3 (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_APattern) (d_C_nextTVar x3500) (d_C_getTypeVariant x2 x3500) (Curry_ErrorState.d_C_mapES d_OP_annPattern_dot_annPVar_dot_189 x3 x3500) x3500
     (Curry_FlatCurry.C_LPattern x4) -> Curry_ErrorState.d_C_liftES (d_OP_annPattern_dot___hash_lambda31 x4) (d_C_nextTVar x3500) x3500
     (Curry_FlatCurry.Choice_C_Pattern x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_annPattern x1002 x3500) (d_C_annPattern x1003 x3500)
     (Curry_FlatCurry.Choices_C_Pattern x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_annPattern z x3500) x1002
     (Curry_FlatCurry.Guard_C_Pattern x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_annPattern x1002) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_Pattern x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_C_annPattern :: Curry_FlatCurry.C_Pattern -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_APattern Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_annPattern x1 x3000 x3500 = case x1 of
     (Curry_FlatCurry.C_Pattern x2 x3) -> let
          x2004 = x3000
           in (seq x2004 (let
               x2005 = leftSupply x2004
               x2006 = rightSupply x2004
                in (seq x2005 (seq x2006 (let
                    x2003 = leftSupply x2005
                    x2000 = rightSupply x2005
                     in (seq x2003 (seq x2000 (let
                         x2001 = leftSupply x2006
                         x2002 = rightSupply x2006
                          in (seq x2001 (seq x2002 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_APattern)) (nd_C_nextTVar x2000 x3500) (nd_C_getTypeVariant x2 x2001 x3500) (Curry_ErrorState.nd_C_mapES (wrapNX id nd_OP_annPattern_dot_annPVar_dot_189) x3 x2002 x3500) x2003 x3500)))))))))))
     (Curry_FlatCurry.C_LPattern x4) -> let
          x2002 = x3000
           in (seq x2002 (let
               x2001 = leftSupply x2002
               x2000 = rightSupply x2002
                in (seq x2001 (seq x2000 (Curry_ErrorState.nd_C_liftES (wrapDX id (d_OP_annPattern_dot___hash_lambda31 x4)) (nd_C_nextTVar x2000 x3500) x2001 x3500)))))
     (Curry_FlatCurry.Choice_C_Pattern x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_C_annPattern x1002 x3000 x3500) (nd_C_annPattern x1003 x3000 x3500)
     (Curry_FlatCurry.Choices_C_Pattern x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_C_annPattern z x3000 x3500) x1002
     (Curry_FlatCurry.Guard_C_Pattern x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_C_annPattern x1002 x3000) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_Pattern x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP_annPattern_dot_annPVar_dot_189 :: Curry_Prelude.C_Int -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP_annPattern_dot_annPVar_dot_189 x1 x3500 = Curry_ErrorState.d_OP_gt_plus (d_C_checkShadowing x1 x3500) (d_C_annVar x1 x3500) x3500

nd_OP_annPattern_dot_annPVar_dot_189 :: Curry_Prelude.C_Int -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP_annPattern_dot_annPVar_dot_189 x1 x3000 x3500 = let
     x2003 = x3000
      in (seq x2003 (let
          x2002 = leftSupply x2003
          x2004 = rightSupply x2003
           in (seq x2002 (seq x2004 (let
               x2000 = leftSupply x2004
               x2001 = rightSupply x2004
                in (seq x2000 (seq x2001 (Curry_ErrorState.nd_OP_gt_plus (nd_C_checkShadowing x1 x2000 x3500) (nd_C_annVar x1 x2001 x3500) x2002 x3500))))))))

d_OP_annPattern_dot___hash_lambda31 :: Curry_FlatCurry.C_Literal -> Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_AnnotatedFlatCurry.C_APattern Curry_FlatCurry.C_TypeExpr
d_OP_annPattern_dot___hash_lambda31 x1 x2 x3500 = Curry_AnnotatedFlatCurry.C_ALPattern x2 x1

d_C_inferAProg :: Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_inferAProg x1 x3500 = case x1 of
     (Curry_AnnotatedFlatCurry.C_AProg x2 x3 x4 x5 x6) -> Curry_ErrorState.d_C_liftES (d_OP_inferAProg_dot___hash_lambda32 x3 x2 x6 x4) (Curry_ErrorState.d_C_mapES d_C_inferFunc x5 x3500) x3500
     (Curry_AnnotatedFlatCurry.Choice_C_AProg x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_inferAProg x1002 x3500) (d_C_inferAProg x1003 x3500)
     (Curry_AnnotatedFlatCurry.Choices_C_AProg x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_inferAProg z x3500) x1002
     (Curry_AnnotatedFlatCurry.Guard_C_AProg x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_inferAProg x1002) $! (addCs x1001 x3500))
     (Curry_AnnotatedFlatCurry.Fail_C_AProg x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_C_inferAProg :: Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_inferAProg x1 x3000 x3500 = case x1 of
     (Curry_AnnotatedFlatCurry.C_AProg x2 x3 x4 x5 x6) -> let
          x2002 = x3000
           in (seq x2002 (let
               x2001 = leftSupply x2002
               x2000 = rightSupply x2002
                in (seq x2001 (seq x2000 (Curry_ErrorState.nd_C_liftES (wrapDX id (d_OP_inferAProg_dot___hash_lambda32 x3 x2 x6 x4)) (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_inferFunc) x5 x2000 x3500) x2001 x3500)))))
     (Curry_AnnotatedFlatCurry.Choice_C_AProg x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_C_inferAProg x1002 x3000 x3500) (nd_C_inferAProg x1003 x3000 x3500)
     (Curry_AnnotatedFlatCurry.Choices_C_AProg x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_C_inferAProg z x3000 x3500) x1002
     (Curry_AnnotatedFlatCurry.Guard_C_AProg x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_C_inferAProg x1002 x3000) $! (addCs x1001 x3500))
     (Curry_AnnotatedFlatCurry.Fail_C_AProg x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP_inferAProg_dot___hash_lambda32 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_FlatCurry.C_OpDecl -> Curry_Prelude.OP_List Curry_FlatCurry.C_TypeDecl -> Curry_Prelude.OP_List (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr
d_OP_inferAProg_dot___hash_lambda32 x1 x2 x3 x4 x5 x3500 = Curry_AnnotatedFlatCurry.C_AProg x2 x1 x4 x5 x3

d_C_inferFunc :: Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_inferFunc x1 x3500 = case x1 of
     (Curry_AnnotatedFlatCurry.C_AFunc x2 x3 x4 x5 x6) -> Curry_ErrorState.d_OP_gt_plus_eq (d_C_inferRule x5 x6 x3500) (d_OP_inferFunc_dot___hash_lambda33 x1)
     (Curry_AnnotatedFlatCurry.Choice_C_AFuncDecl x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_inferFunc x1002 x3500) (d_C_inferFunc x1003 x3500)
     (Curry_AnnotatedFlatCurry.Choices_C_AFuncDecl x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_inferFunc z x3500) x1002
     (Curry_AnnotatedFlatCurry.Guard_C_AFuncDecl x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_inferFunc x1002) $! (addCs x1001 x3500))
     (Curry_AnnotatedFlatCurry.Fail_C_AFuncDecl x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_C_inferFunc :: Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_inferFunc x1 x3000 x3500 = case x1 of
     (Curry_AnnotatedFlatCurry.C_AFunc x2 x3 x4 x5 x6) -> let
          x2000 = x3000
           in (seq x2000 (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_inferRule x5 x6 x2000 x3500) (wrapNX id (nd_OP_inferFunc_dot___hash_lambda33 x1)))))
     (Curry_AnnotatedFlatCurry.Choice_C_AFuncDecl x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_C_inferFunc x1002 x3000 x3500) (nd_C_inferFunc x1003 x3000 x3500)
     (Curry_AnnotatedFlatCurry.Choices_C_AFuncDecl x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_C_inferFunc z x3000 x3500) x1002
     (Curry_AnnotatedFlatCurry.Guard_C_AFuncDecl x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_C_inferFunc x1002 x3000) $! (addCs x1001 x3500))
     (Curry_AnnotatedFlatCurry.Fail_C_AFuncDecl x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP_inferFunc_dot___hash_lambda33 :: Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP_inferFunc_dot___hash_lambda33 x1 x2 x3500 = Curry_ErrorState.d_OP_gt_plus_eq (d_C_unification x2 x3500) (d_OP_inferFunc_dot___hash_lambda33_dot___hash_lambda34 x1)

nd_OP_inferFunc_dot___hash_lambda33 :: Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr) -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP_inferFunc_dot___hash_lambda33 x1 x2 x3000 x3500 = let
     x2000 = x3000
      in (seq x2000 (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_unification x2 x2000 x3500) (wrapNX id (nd_OP_inferFunc_dot___hash_lambda33_dot___hash_lambda34 x1)))))

d_OP_inferFunc_dot___hash_lambda33_dot___hash_lambda34 :: Curry_Prelude.Curry t0 => Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr -> ConstStore -> t0 -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) t0)
d_OP_inferFunc_dot___hash_lambda33_dot___hash_lambda34 x1 x2 x3500 = Curry_Prelude.d_OP_dollar d_C_normFunc (Curry_AFCSubst.d_C_substFunc x2 x1 x3500) x3500

nd_OP_inferFunc_dot___hash_lambda33_dot___hash_lambda34 :: Curry_Prelude.Curry t0 => Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func t0 (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) t0))
nd_OP_inferFunc_dot___hash_lambda33_dot___hash_lambda34 x1 x2 x3000 x3500 = let
     x2002 = x3000
      in (seq x2002 (let
          x2001 = leftSupply x2002
          x2000 = rightSupply x2002
           in (seq x2001 (seq x2000 (Curry_Prelude.nd_OP_dollar (wrapNX id nd_C_normFunc) (Curry_AFCSubst.nd_C_substFunc x2 x1 x2000 x3500) x2001 x3500)))))

d_OP_eq_dot_eq :: Curry_FlatCurry.C_TypeExpr -> Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr
d_OP_eq_dot_eq x1 x2 x3500 = Curry_Prelude.OP_Tuple2 x1 x2

d_C_showTypeEqs :: ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showTypeEqs x3500 = Curry_Prelude.d_OP_dot Curry_Prelude.d_C_unlines (Curry_Prelude.d_C_map d_OP_showTypeEqs_dot_showEquation_dot_208) x3500

nd_C_showTypeEqs :: IDSupply -> ConstStore -> Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_C_showTypeEqs x3000 x3500 = let
     x2000 = x3000
      in (seq x2000 (Curry_Prelude.nd_OP_dot (wrapDX id Curry_Prelude.d_C_unlines) (wrapNX id (Curry_Prelude.nd_C_map (wrapDX id d_OP_showTypeEqs_dot_showEquation_dot_208))) x2000 x3500))

d_OP_showTypeEqs_dot_showEquation_dot_208 :: (Curry_Prelude.Curry t0,Curry_Prelude.Curry t1) => Curry_Prelude.OP_Tuple2 t0 t1 -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_showTypeEqs_dot_showEquation_dot_208 x1 x3500 = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_show x2 x3500) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '='#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '.'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '='#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List))))) (Curry_Prelude.d_C_show x3 x3500) x3500) x3500
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP_showTypeEqs_dot_showEquation_dot_208 x1002 x3500) (d_OP_showTypeEqs_dot_showEquation_dot_208 x1003 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP_showTypeEqs_dot_showEquation_dot_208 z x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP_showTypeEqs_dot_showEquation_dot_208 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple2 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_inferRule :: Curry_FlatCurry.C_TypeExpr -> Curry_AnnotatedFlatCurry.C_ARule Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_inferRule x1 x2 x3500 = case x2 of
     (Curry_AnnotatedFlatCurry.C_ARule x3 x4 x5) -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq x3500) (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 x3 x3500) (d_C_matchApp (Curry_Prelude.d_C_apply (d_C_exprType x3500) x5 x3500) x1 (Curry_Prelude.d_C_map Curry_Prelude.d_C_snd x4 x3500) x3500))) x3500) (d_C_inferExpr x5 x3500) x3500
     (Curry_AnnotatedFlatCurry.C_AExternal x6 x7) -> Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 x6 x3500) Curry_Prelude.OP_List)
     (Curry_AnnotatedFlatCurry.Choice_C_ARule x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_inferRule x1 x1002 x3500) (d_C_inferRule x1 x1003 x3500)
     (Curry_AnnotatedFlatCurry.Choices_C_ARule x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_inferRule x1 z x3500) x1002
     (Curry_AnnotatedFlatCurry.Guard_C_ARule x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_inferRule x1 x1002) $! (addCs x1001 x3500))
     (Curry_AnnotatedFlatCurry.Fail_C_ARule x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_C_inferRule :: Curry_FlatCurry.C_TypeExpr -> Curry_AnnotatedFlatCurry.C_ARule Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_inferRule x1 x2 x3000 x3500 = case x2 of
     (Curry_AnnotatedFlatCurry.C_ARule x3 x4 x5) -> let
          x2011 = x3000
           in (seq x2011 (let
               x2010 = leftSupply x2011
               x2012 = rightSupply x2011
                in (seq x2010 (seq x2012 (let
                    x2007 = leftSupply x2012
                    x2009 = rightSupply x2012
                     in (seq x2007 (seq x2009 (Curry_Prelude.nd_C_apply (let
                         x2006 = leftSupply x2007
                         x2008 = rightSupply x2007
                          in (seq x2006 (seq x2008 (let
                              x2000 = leftSupply x2008
                              x2005 = rightSupply x2008
                               in (seq x2000 (seq x2005 (Curry_Prelude.nd_C_apply (nd_OP_plus_plus_eq x2000 x3500) (wrapDX id (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 x3 x3500) (let
                                   x2003 = leftSupply x2005
                                   x2004 = rightSupply x2005
                                    in (seq x2003 (seq x2004 (d_C_matchApp (let
                                        x2002 = leftSupply x2003
                                        x2001 = rightSupply x2003
                                         in (seq x2002 (seq x2001 (Curry_Prelude.nd_C_apply (nd_C_exprType x2001 x3500) x5 x2002 x3500)))) x1 (Curry_Prelude.nd_C_map (wrapDX id Curry_Prelude.d_C_snd) x4 x2004 x3500) x3500))))))) x2006 x3500))))))) (nd_C_inferExpr x5 x2009 x3500) x2010 x3500))))))))
     (Curry_AnnotatedFlatCurry.C_AExternal x6 x7) -> wrapDX id (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 x6 x3500) Curry_Prelude.OP_List))
     (Curry_AnnotatedFlatCurry.Choice_C_ARule x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_C_inferRule x1 x1002 x3000 x3500) (nd_C_inferRule x1 x1003 x3000 x3500)
     (Curry_AnnotatedFlatCurry.Choices_C_ARule x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_C_inferRule x1 z x3000 x3500) x1002
     (Curry_AnnotatedFlatCurry.Guard_C_ARule x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_C_inferRule x1 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_AnnotatedFlatCurry.Fail_C_ARule x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_matchApp :: Curry_FlatCurry.C_TypeExpr -> Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_List Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)
d_C_matchApp x1 x2 x3 x3500 = case x3 of
     Curry_Prelude.OP_List -> Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 x2 x3500) Curry_Prelude.OP_List
     (Curry_Prelude.OP_Cons x4 x5) -> d_OP__case_12 x5 x1 x4 x2 x3500
     (Curry_Prelude.Choice_OP_List x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_matchApp x1 x2 x1002 x3500) (d_C_matchApp x1 x2 x1003 x3500)
     (Curry_Prelude.Choices_OP_List x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_matchApp x1 x2 z x3500) x1002
     (Curry_Prelude.Guard_OP_List x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_matchApp x1 x2 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_List x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_inferExpr :: Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_inferExpr x1 x3500 = case x1 of
     (Curry_AnnotatedFlatCurry.C_AVar x2 x3) -> Curry_ErrorState.d_C_returnES Curry_Prelude.OP_List
     (Curry_AnnotatedFlatCurry.C_ALit x4 x5) -> Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x4 (d_C_literalType x5 x3500) x3500) Curry_Prelude.OP_List)
     (Curry_AnnotatedFlatCurry.C_AComb x6 x7 x8 x9) -> d_OP__case_11 x9 x6 x8 x3500
     (Curry_AnnotatedFlatCurry.C_ACase x12 x13 x14 x15) -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq x3500) (d_C_inferExpr x14 x3500) x3500) (Curry_ErrorState.d_C_concatMapES (d_C_inferBranch x12 x14) x15 x3500) x3500
     (Curry_AnnotatedFlatCurry.C_AOr x16 x17 x18) -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq x3500) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq x3500) (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq (Curry_Prelude.d_C_apply (d_C_exprType x3500) x17 x3500) x16 x3500) (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq (Curry_Prelude.d_C_apply (d_C_exprType x3500) x18 x3500) x16 x3500) Curry_Prelude.OP_List))) x3500) (d_C_inferExpr x17 x3500) x3500) x3500) (d_C_inferExpr x18 x3500) x3500
     (Curry_AnnotatedFlatCurry.C_ALet x19 x20 x21) -> let
          x22 = Curry_Prelude.d_C_map d_OP_inferExpr_dot___hash_lambda35 x20 x3500
           in (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq x3500) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq x3500) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq x3500) (Curry_ErrorState.d_C_concatMapES (d_C_inferVars x22) (Curry_Prelude.OP_Cons x21 (Curry_Prelude.d_C_map Curry_Prelude.d_C_snd x20 x3500)) x3500) x3500) (Curry_ErrorState.d_C_concatMapES d_C_inferExpr (Curry_Prelude.d_C_map Curry_Prelude.d_C_snd x20 x3500) x3500) x3500) x3500) (d_C_inferExpr x21 x3500) x3500) x3500) (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x19 (Curry_Prelude.d_C_apply (d_C_exprType x3500) x21 x3500) x3500) Curry_Prelude.OP_List)) x3500)
     (Curry_AnnotatedFlatCurry.C_AFree x23 x24 x25) -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq x3500) (d_C_inferExpr x25 x3500) x3500) (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x23 (Curry_Prelude.d_C_apply (d_C_exprType x3500) x25 x3500) x3500) Curry_Prelude.OP_List)) x3500
     (Curry_AnnotatedFlatCurry.C_ATyped x26 x27 x28) -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq x3500) (d_C_inferExpr x27 x3500) x3500) (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq (Curry_Prelude.d_C_apply (d_C_exprType x3500) x27 x3500) x26 x3500) (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq (Curry_Prelude.d_C_apply (d_C_exprType x3500) x27 x3500) x28 x3500) Curry_Prelude.OP_List))) x3500
     (Curry_AnnotatedFlatCurry.Choice_C_AExpr x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_inferExpr x1002 x3500) (d_C_inferExpr x1003 x3500)
     (Curry_AnnotatedFlatCurry.Choices_C_AExpr x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_inferExpr z x3500) x1002
     (Curry_AnnotatedFlatCurry.Guard_C_AExpr x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_inferExpr x1002) $! (addCs x1001 x3500))
     (Curry_AnnotatedFlatCurry.Fail_C_AExpr x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_C_inferExpr :: Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_inferExpr x1 x3000 x3500 = case x1 of
     (Curry_AnnotatedFlatCurry.C_AVar x2 x3) -> wrapDX id (Curry_ErrorState.d_C_returnES Curry_Prelude.OP_List)
     (Curry_AnnotatedFlatCurry.C_ALit x4 x5) -> wrapDX id (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x4 (d_C_literalType x5 x3500) x3500) Curry_Prelude.OP_List))
     (Curry_AnnotatedFlatCurry.C_AComb x6 x7 x8 x9) -> let
          x2000 = x3000
           in (seq x2000 (nd_OP__case_11 x9 x6 x8 x2000 x3500))
     (Curry_AnnotatedFlatCurry.C_ACase x12 x13 x14 x15) -> let
          x2007 = x3000
           in (seq x2007 (let
               x2006 = leftSupply x2007
               x2008 = rightSupply x2007
                in (seq x2006 (seq x2008 (let
                    x2003 = leftSupply x2008
                    x2005 = rightSupply x2008
                     in (seq x2003 (seq x2005 (Curry_Prelude.nd_C_apply (let
                         x2002 = leftSupply x2003
                         x2004 = rightSupply x2003
                          in (seq x2002 (seq x2004 (let
                              x2000 = leftSupply x2004
                              x2001 = rightSupply x2004
                               in (seq x2000 (seq x2001 (Curry_Prelude.nd_C_apply (nd_OP_plus_plus_eq x2000 x3500) (nd_C_inferExpr x14 x2001 x3500) x2002 x3500))))))) (Curry_ErrorState.nd_C_concatMapES (wrapNX id (nd_C_inferBranch x12 x14)) x15 x2005 x3500) x2006 x3500))))))))
     (Curry_AnnotatedFlatCurry.C_AOr x16 x17 x18) -> let
          x2021 = x3000
           in (seq x2021 (let
               x2020 = leftSupply x2021
               x2022 = rightSupply x2021
                in (seq x2020 (seq x2022 (let
                    x2017 = leftSupply x2022
                    x2019 = rightSupply x2022
                     in (seq x2017 (seq x2019 (Curry_Prelude.nd_C_apply (let
                         x2016 = leftSupply x2017
                         x2018 = rightSupply x2017
                          in (seq x2016 (seq x2018 (let
                              x2000 = leftSupply x2018
                              x2014 = rightSupply x2018
                               in (seq x2000 (seq x2014 (Curry_Prelude.nd_C_apply (nd_OP_plus_plus_eq x2000 x3500) (let
                                   x2013 = leftSupply x2014
                                   x2015 = rightSupply x2014
                                    in (seq x2013 (seq x2015 (let
                                        x2010 = leftSupply x2015
                                        x2012 = rightSupply x2015
                                         in (seq x2010 (seq x2012 (Curry_Prelude.nd_C_apply (let
                                             x2009 = leftSupply x2010
                                             x2011 = rightSupply x2010
                                              in (seq x2009 (seq x2011 (let
                                                  x2001 = leftSupply x2011
                                                  x2008 = rightSupply x2011
                                                   in (seq x2001 (seq x2008 (Curry_Prelude.nd_C_apply (nd_OP_plus_plus_eq x2001 x3500) (wrapDX id (Curry_ErrorState.d_C_returnES (let
                                                       x2004 = leftSupply x2008
                                                       x2007 = rightSupply x2008
                                                        in (seq x2004 (seq x2007 (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq (let
                                                            x2003 = leftSupply x2004
                                                            x2002 = rightSupply x2004
                                                             in (seq x2003 (seq x2002 (Curry_Prelude.nd_C_apply (nd_C_exprType x2002 x3500) x17 x2003 x3500)))) x16 x3500) (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq (let
                                                            x2006 = leftSupply x2007
                                                            x2005 = rightSupply x2007
                                                             in (seq x2006 (seq x2005 (Curry_Prelude.nd_C_apply (nd_C_exprType x2005 x3500) x18 x2006 x3500)))) x16 x3500) Curry_Prelude.OP_List))))))) x2009 x3500))))))) (nd_C_inferExpr x17 x2012 x3500) x2013 x3500))))))) x2016 x3500))))))) (nd_C_inferExpr x18 x2019 x3500) x2020 x3500))))))))
     (Curry_AnnotatedFlatCurry.C_ALet x19 x20 x21) -> let
          x2032 = x3000
           in (seq x2032 (let
               x2000 = leftSupply x2032
               x2030 = rightSupply x2032
                in (seq x2000 (seq x2030 (let
                    x22 = Curry_Prelude.nd_C_map (wrapDX id d_OP_inferExpr_dot___hash_lambda35) x20 x2000 x3500
                     in (let
                         x2029 = leftSupply x2030
                         x2031 = rightSupply x2030
                          in (seq x2029 (seq x2031 (let
                              x2024 = leftSupply x2031
                              x2028 = rightSupply x2031
                               in (seq x2024 (seq x2028 (Curry_Prelude.nd_C_apply (let
                                   x2023 = leftSupply x2024
                                   x2025 = rightSupply x2024
                                    in (seq x2023 (seq x2025 (let
                                        x2001 = leftSupply x2025
                                        x2021 = rightSupply x2025
                                         in (seq x2001 (seq x2021 (Curry_Prelude.nd_C_apply (nd_OP_plus_plus_eq x2001 x3500) (let
                                             x2020 = leftSupply x2021
                                             x2022 = rightSupply x2021
                                              in (seq x2020 (seq x2022 (let
                                                  x2017 = leftSupply x2022
                                                  x2019 = rightSupply x2022
                                                   in (seq x2017 (seq x2019 (Curry_Prelude.nd_C_apply (let
                                                       x2016 = leftSupply x2017
                                                       x2018 = rightSupply x2017
                                                        in (seq x2016 (seq x2018 (let
                                                            x2002 = leftSupply x2018
                                                            x2014 = rightSupply x2018
                                                             in (seq x2002 (seq x2014 (Curry_Prelude.nd_C_apply (nd_OP_plus_plus_eq x2002 x3500) (let
                                                                 x2013 = leftSupply x2014
                                                                 x2015 = rightSupply x2014
                                                                  in (seq x2013 (seq x2015 (let
                                                                      x2008 = leftSupply x2015
                                                                      x2012 = rightSupply x2015
                                                                       in (seq x2008 (seq x2012 (Curry_Prelude.nd_C_apply (let
                                                                           x2007 = leftSupply x2008
                                                                           x2009 = rightSupply x2008
                                                                            in (seq x2007 (seq x2009 (let
                                                                                x2003 = leftSupply x2009
                                                                                x2006 = rightSupply x2009
                                                                                 in (seq x2003 (seq x2006 (Curry_Prelude.nd_C_apply (nd_OP_plus_plus_eq x2003 x3500) (let
                                                                                     x2005 = leftSupply x2006
                                                                                     x2004 = rightSupply x2006
                                                                                      in (seq x2005 (seq x2004 (Curry_ErrorState.nd_C_concatMapES (wrapNX id (nd_C_inferVars x22)) (Curry_Prelude.OP_Cons x21 (Curry_Prelude.nd_C_map (wrapDX id Curry_Prelude.d_C_snd) x20 x2004 x3500)) x2005 x3500)))) x2007 x3500))))))) (let
                                                                           x2011 = leftSupply x2012
                                                                           x2010 = rightSupply x2012
                                                                            in (seq x2011 (seq x2010 (Curry_ErrorState.nd_C_concatMapES (wrapNX id nd_C_inferExpr) (Curry_Prelude.nd_C_map (wrapDX id Curry_Prelude.d_C_snd) x20 x2010 x3500) x2011 x3500)))) x2013 x3500))))))) x2016 x3500))))))) (nd_C_inferExpr x21 x2019 x3500) x2020 x3500))))))) x2023 x3500))))))) (wrapDX id (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x19 (let
                                   x2027 = leftSupply x2028
                                   x2026 = rightSupply x2028
                                    in (seq x2027 (seq x2026 (Curry_Prelude.nd_C_apply (nd_C_exprType x2026 x3500) x21 x2027 x3500)))) x3500) Curry_Prelude.OP_List))) x2029 x3500))))))))))))
     (Curry_AnnotatedFlatCurry.C_AFree x23 x24 x25) -> let
          x2009 = x3000
           in (seq x2009 (let
               x2008 = leftSupply x2009
               x2010 = rightSupply x2009
                in (seq x2008 (seq x2010 (let
                    x2003 = leftSupply x2010
                    x2007 = rightSupply x2010
                     in (seq x2003 (seq x2007 (Curry_Prelude.nd_C_apply (let
                         x2002 = leftSupply x2003
                         x2004 = rightSupply x2003
                          in (seq x2002 (seq x2004 (let
                              x2000 = leftSupply x2004
                              x2001 = rightSupply x2004
                               in (seq x2000 (seq x2001 (Curry_Prelude.nd_C_apply (nd_OP_plus_plus_eq x2000 x3500) (nd_C_inferExpr x25 x2001 x3500) x2002 x3500))))))) (wrapDX id (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x23 (let
                         x2006 = leftSupply x2007
                         x2005 = rightSupply x2007
                          in (seq x2006 (seq x2005 (Curry_Prelude.nd_C_apply (nd_C_exprType x2005 x3500) x25 x2006 x3500)))) x3500) Curry_Prelude.OP_List))) x2008 x3500))))))))
     (Curry_AnnotatedFlatCurry.C_ATyped x26 x27 x28) -> let
          x2013 = x3000
           in (seq x2013 (let
               x2012 = leftSupply x2013
               x2014 = rightSupply x2013
                in (seq x2012 (seq x2014 (let
                    x2003 = leftSupply x2014
                    x2011 = rightSupply x2014
                     in (seq x2003 (seq x2011 (Curry_Prelude.nd_C_apply (let
                         x2002 = leftSupply x2003
                         x2004 = rightSupply x2003
                          in (seq x2002 (seq x2004 (let
                              x2000 = leftSupply x2004
                              x2001 = rightSupply x2004
                               in (seq x2000 (seq x2001 (Curry_Prelude.nd_C_apply (nd_OP_plus_plus_eq x2000 x3500) (nd_C_inferExpr x27 x2001 x3500) x2002 x3500))))))) (wrapDX id (Curry_ErrorState.d_C_returnES (let
                         x2007 = leftSupply x2011
                         x2010 = rightSupply x2011
                          in (seq x2007 (seq x2010 (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq (let
                              x2006 = leftSupply x2007
                              x2005 = rightSupply x2007
                               in (seq x2006 (seq x2005 (Curry_Prelude.nd_C_apply (nd_C_exprType x2005 x3500) x27 x2006 x3500)))) x26 x3500) (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq (let
                              x2009 = leftSupply x2010
                              x2008 = rightSupply x2010
                               in (seq x2009 (seq x2008 (Curry_Prelude.nd_C_apply (nd_C_exprType x2008 x3500) x27 x2009 x3500)))) x28 x3500) Curry_Prelude.OP_List))))))) x2012 x3500))))))))
     (Curry_AnnotatedFlatCurry.Choice_C_AExpr x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_C_inferExpr x1002 x3000 x3500) (nd_C_inferExpr x1003 x3000 x3500)
     (Curry_AnnotatedFlatCurry.Choices_C_AExpr x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_C_inferExpr z x3000 x3500) x1002
     (Curry_AnnotatedFlatCurry.Guard_C_AExpr x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_C_inferExpr x1002 x3000) $! (addCs x1001 x3500))
     (Curry_AnnotatedFlatCurry.Fail_C_AExpr x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP_inferExpr_dot___hash_lambda35 :: Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr
d_OP_inferExpr_dot___hash_lambda35 x1 x3500 = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> Curry_Prelude.OP_Tuple2 x2 (Curry_Prelude.d_C_apply (d_C_exprType x3500) x3 x3500)
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP_inferExpr_dot___hash_lambda35 x1002 x3500) (d_OP_inferExpr_dot___hash_lambda35 x1003 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP_inferExpr_dot___hash_lambda35 z x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP_inferExpr_dot___hash_lambda35 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple2 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_inferBranch :: Curry_FlatCurry.C_TypeExpr -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr -> Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_inferBranch x1 x2 x3 x3500 = case x3 of
     (Curry_AnnotatedFlatCurry.C_ABranch x4 x5) -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq x3500) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq x3500) (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 (Curry_Prelude.d_C_apply (d_C_exprType x3500) x5 x3500) x3500) Curry_Prelude.OP_List)) x3500) (d_C_inferPattern (Curry_Prelude.d_C_apply (d_C_exprType x3500) x2 x3500) x4 x3500) x3500) x3500) (d_C_inferExpr x5 x3500) x3500
     (Curry_AnnotatedFlatCurry.Choice_C_ABranchExpr x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_inferBranch x1 x2 x1002 x3500) (d_C_inferBranch x1 x2 x1003 x3500)
     (Curry_AnnotatedFlatCurry.Choices_C_ABranchExpr x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_inferBranch x1 x2 z x3500) x1002
     (Curry_AnnotatedFlatCurry.Guard_C_ABranchExpr x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_inferBranch x1 x2 x1002) $! (addCs x1001 x3500))
     (Curry_AnnotatedFlatCurry.Fail_C_ABranchExpr x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_C_inferBranch :: Curry_FlatCurry.C_TypeExpr -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr -> Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_inferBranch x1 x2 x3 x3000 x3500 = case x3 of
     (Curry_AnnotatedFlatCurry.C_ABranch x4 x5) -> let
          x2021 = x3000
           in (seq x2021 (let
               x2020 = leftSupply x2021
               x2022 = rightSupply x2021
                in (seq x2020 (seq x2022 (let
                    x2017 = leftSupply x2022
                    x2019 = rightSupply x2022
                     in (seq x2017 (seq x2019 (Curry_Prelude.nd_C_apply (let
                         x2016 = leftSupply x2017
                         x2018 = rightSupply x2017
                          in (seq x2016 (seq x2018 (let
                              x2000 = leftSupply x2018
                              x2014 = rightSupply x2018
                               in (seq x2000 (seq x2014 (Curry_Prelude.nd_C_apply (nd_OP_plus_plus_eq x2000 x3500) (let
                                   x2013 = leftSupply x2014
                                   x2015 = rightSupply x2014
                                    in (seq x2013 (seq x2015 (let
                                        x2006 = leftSupply x2015
                                        x2012 = rightSupply x2015
                                         in (seq x2006 (seq x2012 (Curry_Prelude.nd_C_apply (let
                                             x2005 = leftSupply x2006
                                             x2007 = rightSupply x2006
                                              in (seq x2005 (seq x2007 (let
                                                  x2001 = leftSupply x2007
                                                  x2004 = rightSupply x2007
                                                   in (seq x2001 (seq x2004 (Curry_Prelude.nd_C_apply (nd_OP_plus_plus_eq x2001 x3500) (wrapDX id (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 (let
                                                       x2003 = leftSupply x2004
                                                       x2002 = rightSupply x2004
                                                        in (seq x2003 (seq x2002 (Curry_Prelude.nd_C_apply (nd_C_exprType x2002 x3500) x5 x2003 x3500)))) x3500) Curry_Prelude.OP_List))) x2005 x3500))))))) (let
                                             x2011 = leftSupply x2012
                                             x2010 = rightSupply x2012
                                              in (seq x2011 (seq x2010 (nd_C_inferPattern (let
                                                  x2009 = leftSupply x2010
                                                  x2008 = rightSupply x2010
                                                   in (seq x2009 (seq x2008 (Curry_Prelude.nd_C_apply (nd_C_exprType x2008 x3500) x2 x2009 x3500)))) x4 x2011 x3500)))) x2013 x3500))))))) x2016 x3500))))))) (nd_C_inferExpr x5 x2019 x3500) x2020 x3500))))))))
     (Curry_AnnotatedFlatCurry.Choice_C_ABranchExpr x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_C_inferBranch x1 x2 x1002 x3000 x3500) (nd_C_inferBranch x1 x2 x1003 x3000 x3500)
     (Curry_AnnotatedFlatCurry.Choices_C_ABranchExpr x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_C_inferBranch x1 x2 z x3000 x3500) x1002
     (Curry_AnnotatedFlatCurry.Guard_C_ABranchExpr x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_C_inferBranch x1 x2 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_AnnotatedFlatCurry.Fail_C_ABranchExpr x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_inferPattern :: Curry_FlatCurry.C_TypeExpr -> Curry_AnnotatedFlatCurry.C_APattern Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_inferPattern x1 x2 x3500 = case x2 of
     (Curry_AnnotatedFlatCurry.C_APattern x3 x4 x5) -> d_OP__case_10 x5 x3 x1 x4 x3500
     (Curry_AnnotatedFlatCurry.C_ALPattern x8 x9) -> Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 x8 x3500) (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x8 (d_C_literalType x9 x3500) x3500) Curry_Prelude.OP_List))
     (Curry_AnnotatedFlatCurry.Choice_C_APattern x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_inferPattern x1 x1002 x3500) (d_C_inferPattern x1 x1003 x3500)
     (Curry_AnnotatedFlatCurry.Choices_C_APattern x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_inferPattern x1 z x3500) x1002
     (Curry_AnnotatedFlatCurry.Guard_C_APattern x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_inferPattern x1 x1002) $! (addCs x1001 x3500))
     (Curry_AnnotatedFlatCurry.Fail_C_APattern x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_C_inferPattern :: Curry_FlatCurry.C_TypeExpr -> Curry_AnnotatedFlatCurry.C_APattern Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_inferPattern x1 x2 x3000 x3500 = case x2 of
     (Curry_AnnotatedFlatCurry.C_APattern x3 x4 x5) -> let
          x2000 = x3000
           in (seq x2000 (nd_OP__case_10 x5 x3 x1 x4 x2000 x3500))
     (Curry_AnnotatedFlatCurry.C_ALPattern x8 x9) -> wrapDX id (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 x8 x3500) (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x8 (d_C_literalType x9 x3500) x3500) Curry_Prelude.OP_List)))
     (Curry_AnnotatedFlatCurry.Choice_C_APattern x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_C_inferPattern x1 x1002 x3000 x3500) (nd_C_inferPattern x1 x1003 x3000 x3500)
     (Curry_AnnotatedFlatCurry.Choices_C_APattern x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_C_inferPattern x1 z x3000 x3500) x1002
     (Curry_AnnotatedFlatCurry.Guard_C_APattern x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_C_inferPattern x1 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_AnnotatedFlatCurry.Fail_C_APattern x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_inferVars :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_inferVars x1 x2 x3500 = case x2 of
     (Curry_AnnotatedFlatCurry.C_AComb x3 x4 x5 x6) -> Curry_ErrorState.d_C_concatMapES (d_C_inferVars x1) x6 x3500
     (Curry_AnnotatedFlatCurry.C_ACase x7 x8 x9 x10) -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq x3500) (Curry_ErrorState.d_C_concatMapES (d_OP_inferVars_dot_genBranchVarPairs_dot_260 x1) x10 x3500) x3500) (d_C_inferVars x1 x9 x3500) x3500
     (Curry_AnnotatedFlatCurry.C_AVar x11 x12) -> d_OP__case_9 x1 x12 x11 (Curry_Prelude.d_C_lookup x12 x1 x3500) x3500
     (Curry_AnnotatedFlatCurry.C_ALit x14 x15) -> Curry_ErrorState.d_C_returnES Curry_Prelude.OP_List
     (Curry_AnnotatedFlatCurry.C_AOr x16 x17 x18) -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq x3500) (d_C_inferVars x1 x17 x3500) x3500) (d_C_inferVars x1 x18 x3500) x3500
     (Curry_AnnotatedFlatCurry.C_ALet x19 x20 x21) -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq x3500) (Curry_ErrorState.d_C_concatMapES (d_C_inferVars x1) (Curry_Prelude.d_C_map Curry_Prelude.d_C_snd x20 x3500) x3500) x3500) (d_C_inferVars x1 x21 x3500) x3500
     (Curry_AnnotatedFlatCurry.C_AFree x22 x23 x24) -> d_C_inferVars x1 x24 x3500
     (Curry_AnnotatedFlatCurry.C_ATyped x25 x26 x27) -> d_C_inferVars x1 x26 x3500
     (Curry_AnnotatedFlatCurry.Choice_C_AExpr x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_inferVars x1 x1002 x3500) (d_C_inferVars x1 x1003 x3500)
     (Curry_AnnotatedFlatCurry.Choices_C_AExpr x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_inferVars x1 z x3500) x1002
     (Curry_AnnotatedFlatCurry.Guard_C_AExpr x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_inferVars x1 x1002) $! (addCs x1001 x3500))
     (Curry_AnnotatedFlatCurry.Fail_C_AExpr x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_C_inferVars :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_inferVars x1 x2 x3000 x3500 = case x2 of
     (Curry_AnnotatedFlatCurry.C_AComb x3 x4 x5 x6) -> let
          x2000 = x3000
           in (seq x2000 (Curry_ErrorState.nd_C_concatMapES (wrapNX id (nd_C_inferVars x1)) x6 x2000 x3500))
     (Curry_AnnotatedFlatCurry.C_ACase x7 x8 x9 x10) -> let
          x2007 = x3000
           in (seq x2007 (let
               x2006 = leftSupply x2007
               x2008 = rightSupply x2007
                in (seq x2006 (seq x2008 (let
                    x2003 = leftSupply x2008
                    x2005 = rightSupply x2008
                     in (seq x2003 (seq x2005 (Curry_Prelude.nd_C_apply (let
                         x2002 = leftSupply x2003
                         x2004 = rightSupply x2003
                          in (seq x2002 (seq x2004 (let
                              x2000 = leftSupply x2004
                              x2001 = rightSupply x2004
                               in (seq x2000 (seq x2001 (Curry_Prelude.nd_C_apply (nd_OP_plus_plus_eq x2000 x3500) (Curry_ErrorState.nd_C_concatMapES (wrapNX id (nd_OP_inferVars_dot_genBranchVarPairs_dot_260 x1)) x10 x2001 x3500) x2002 x3500))))))) (nd_C_inferVars x1 x9 x2005 x3500) x2006 x3500))))))))
     (Curry_AnnotatedFlatCurry.C_AVar x11 x12) -> let
          x2000 = x3000
           in (seq x2000 (nd_OP__case_9 x1 x12 x11 (Curry_Prelude.d_C_lookup x12 x1 x3500) x2000 x3500))
     (Curry_AnnotatedFlatCurry.C_ALit x14 x15) -> wrapDX id (Curry_ErrorState.d_C_returnES Curry_Prelude.OP_List)
     (Curry_AnnotatedFlatCurry.C_AOr x16 x17 x18) -> let
          x2007 = x3000
           in (seq x2007 (let
               x2006 = leftSupply x2007
               x2008 = rightSupply x2007
                in (seq x2006 (seq x2008 (let
                    x2003 = leftSupply x2008
                    x2005 = rightSupply x2008
                     in (seq x2003 (seq x2005 (Curry_Prelude.nd_C_apply (let
                         x2002 = leftSupply x2003
                         x2004 = rightSupply x2003
                          in (seq x2002 (seq x2004 (let
                              x2000 = leftSupply x2004
                              x2001 = rightSupply x2004
                               in (seq x2000 (seq x2001 (Curry_Prelude.nd_C_apply (nd_OP_plus_plus_eq x2000 x3500) (nd_C_inferVars x1 x17 x2001 x3500) x2002 x3500))))))) (nd_C_inferVars x1 x18 x2005 x3500) x2006 x3500))))))))
     (Curry_AnnotatedFlatCurry.C_ALet x19 x20 x21) -> let
          x2009 = x3000
           in (seq x2009 (let
               x2008 = leftSupply x2009
               x2010 = rightSupply x2009
                in (seq x2008 (seq x2010 (let
                    x2005 = leftSupply x2010
                    x2007 = rightSupply x2010
                     in (seq x2005 (seq x2007 (Curry_Prelude.nd_C_apply (let
                         x2004 = leftSupply x2005
                         x2006 = rightSupply x2005
                          in (seq x2004 (seq x2006 (let
                              x2000 = leftSupply x2006
                              x2003 = rightSupply x2006
                               in (seq x2000 (seq x2003 (Curry_Prelude.nd_C_apply (nd_OP_plus_plus_eq x2000 x3500) (let
                                   x2002 = leftSupply x2003
                                   x2001 = rightSupply x2003
                                    in (seq x2002 (seq x2001 (Curry_ErrorState.nd_C_concatMapES (wrapNX id (nd_C_inferVars x1)) (Curry_Prelude.nd_C_map (wrapDX id Curry_Prelude.d_C_snd) x20 x2001 x3500) x2002 x3500)))) x2004 x3500))))))) (nd_C_inferVars x1 x21 x2007 x3500) x2008 x3500))))))))
     (Curry_AnnotatedFlatCurry.C_AFree x22 x23 x24) -> let
          x2000 = x3000
           in (seq x2000 (nd_C_inferVars x1 x24 x2000 x3500))
     (Curry_AnnotatedFlatCurry.C_ATyped x25 x26 x27) -> let
          x2000 = x3000
           in (seq x2000 (nd_C_inferVars x1 x26 x2000 x3500))
     (Curry_AnnotatedFlatCurry.Choice_C_AExpr x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_C_inferVars x1 x1002 x3000 x3500) (nd_C_inferVars x1 x1003 x3000 x3500)
     (Curry_AnnotatedFlatCurry.Choices_C_AExpr x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_C_inferVars x1 z x3000 x3500) x1002
     (Curry_AnnotatedFlatCurry.Guard_C_AExpr x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_C_inferVars x1 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_AnnotatedFlatCurry.Fail_C_AExpr x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP_inferVars_dot_genBranchVarPairs_dot_260 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP_inferVars_dot_genBranchVarPairs_dot_260 x1 x2 x3500 = case x2 of
     (Curry_AnnotatedFlatCurry.C_ABranch x3 x4) -> d_C_inferVars x1 x4 x3500
     (Curry_AnnotatedFlatCurry.Choice_C_ABranchExpr x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP_inferVars_dot_genBranchVarPairs_dot_260 x1 x1002 x3500) (d_OP_inferVars_dot_genBranchVarPairs_dot_260 x1 x1003 x3500)
     (Curry_AnnotatedFlatCurry.Choices_C_ABranchExpr x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP_inferVars_dot_genBranchVarPairs_dot_260 x1 z x3500) x1002
     (Curry_AnnotatedFlatCurry.Guard_C_ABranchExpr x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP_inferVars_dot_genBranchVarPairs_dot_260 x1 x1002) $! (addCs x1001 x3500))
     (Curry_AnnotatedFlatCurry.Fail_C_ABranchExpr x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_OP_inferVars_dot_genBranchVarPairs_dot_260 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP_inferVars_dot_genBranchVarPairs_dot_260 x1 x2 x3000 x3500 = case x2 of
     (Curry_AnnotatedFlatCurry.C_ABranch x3 x4) -> let
          x2000 = x3000
           in (seq x2000 (nd_C_inferVars x1 x4 x2000 x3500))
     (Curry_AnnotatedFlatCurry.Choice_C_ABranchExpr x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_OP_inferVars_dot_genBranchVarPairs_dot_260 x1 x1002 x3000 x3500) (nd_OP_inferVars_dot_genBranchVarPairs_dot_260 x1 x1003 x3000 x3500)
     (Curry_AnnotatedFlatCurry.Choices_C_ABranchExpr x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_OP_inferVars_dot_genBranchVarPairs_dot_260 x1 z x3000 x3500) x1002
     (Curry_AnnotatedFlatCurry.Guard_C_ABranchExpr x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_OP_inferVars_dot_genBranchVarPairs_dot_260 x1 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_AnnotatedFlatCurry.Fail_C_ABranchExpr x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_literalType :: Curry_FlatCurry.C_Literal -> ConstStore -> Curry_FlatCurry.C_TypeExpr
d_C_literalType x1 x3500 = case x1 of
     (Curry_FlatCurry.C_Intc x2) -> Curry_FlatCurry.C_TCons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'P'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) Curry_Prelude.OP_List))))))) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'I'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) Curry_Prelude.OP_List)))) Curry_Prelude.OP_List
     (Curry_FlatCurry.C_Floatc x3) -> Curry_FlatCurry.C_TCons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'P'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) Curry_Prelude.OP_List))))))) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'F'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) Curry_Prelude.OP_List)))))) Curry_Prelude.OP_List
     (Curry_FlatCurry.C_Charc x4) -> Curry_FlatCurry.C_TCons (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'P'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) Curry_Prelude.OP_List))))))) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'C'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) Curry_Prelude.OP_List))))) Curry_Prelude.OP_List
     (Curry_FlatCurry.Choice_C_Literal x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_literalType x1002 x3500) (d_C_literalType x1003 x3500)
     (Curry_FlatCurry.Choices_C_Literal x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_literalType z x3500) x1002
     (Curry_FlatCurry.Guard_C_Literal x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_literalType x1002) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_Literal x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_exprType :: ConstStore -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_FlatCurry.C_TypeExpr
d_C_exprType x3500 = Curry_AnnotatedFlatCurryGoodies.d_C_annExpr

nd_C_exprType :: IDSupply -> ConstStore -> Func (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) Curry_FlatCurry.C_TypeExpr
nd_C_exprType x3000 x3500 = wrapDX id Curry_AnnotatedFlatCurryGoodies.d_C_annExpr

d_C_unification :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_C_unification x1 x3500 = d_OP__case_7 x1 (Curry_Unification.d_C_unify (Curry_Prelude.d_C_apply (d_C_fromTypeEqs x3500) x1 x3500) x3500) x3500

nd_C_unification :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr) -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_C_unification x1 x3000 x3500 = let
     x2006 = x3000
      in (seq x2006 (let
          x2005 = leftSupply x2006
          x2004 = rightSupply x2006
           in (seq x2005 (seq x2004 (nd_OP__case_7 x1 (let
               x2003 = leftSupply x2004
               x2002 = rightSupply x2004
                in (seq x2003 (seq x2002 (Curry_Unification.nd_C_unify (let
                    x2001 = leftSupply x2002
                    x2000 = rightSupply x2002
                     in (seq x2001 (seq x2000 (Curry_Prelude.nd_C_apply (nd_C_fromTypeEqs x2000 x3500) x1 x2001 x3500)))) x2003 x3500)))) x2005 x3500)))))

d_OP_unification_dot___hash_lambda38 :: Curry_Prelude.C_Int -> ConstStore -> Curry_UnificationSpec.C_Term -> ConstStore -> Curry_FlatCurry.C_TypeExpr
d_OP_unification_dot___hash_lambda38 x1 x3500 = d_C_toTypeExpr

nd_OP_unification_dot___hash_lambda38 :: Curry_Prelude.C_Int -> IDSupply -> ConstStore -> Func Curry_UnificationSpec.C_Term Curry_FlatCurry.C_TypeExpr
nd_OP_unification_dot___hash_lambda38 x1 x3000 x3500 = wrapDX id d_C_toTypeExpr

d_C_fromTypeEqs :: ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_UnificationSpec.C_Term Curry_UnificationSpec.C_Term)
d_C_fromTypeEqs x3500 = Curry_Prelude.d_C_map d_OP_fromTypeEqs_dot___hash_lambda39

nd_C_fromTypeEqs :: IDSupply -> ConstStore -> Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_UnificationSpec.C_Term Curry_UnificationSpec.C_Term))
nd_C_fromTypeEqs x3000 x3500 = wrapNX id (Curry_Prelude.nd_C_map (wrapDX id d_OP_fromTypeEqs_dot___hash_lambda39))

d_OP_fromTypeEqs_dot___hash_lambda39 :: Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_UnificationSpec.C_Term Curry_UnificationSpec.C_Term
d_OP_fromTypeEqs_dot___hash_lambda39 x1 x3500 = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> Curry_Prelude.OP_Tuple2 (d_C_fromTypeExpr x2 x3500) (d_C_fromTypeExpr x3 x3500)
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP_fromTypeEqs_dot___hash_lambda39 x1002 x3500) (d_OP_fromTypeEqs_dot___hash_lambda39 x1003 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP_fromTypeEqs_dot___hash_lambda39 z x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP_fromTypeEqs_dot___hash_lambda39 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple2 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_toTypeEqs :: ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_UnificationSpec.C_Term Curry_UnificationSpec.C_Term) -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)
d_C_toTypeEqs x3500 = Curry_Prelude.d_C_map d_OP_toTypeEqs_dot___hash_lambda40

nd_C_toTypeEqs :: IDSupply -> ConstStore -> Func (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_UnificationSpec.C_Term Curry_UnificationSpec.C_Term)) (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr))
nd_C_toTypeEqs x3000 x3500 = wrapNX id (Curry_Prelude.nd_C_map (wrapDX id d_OP_toTypeEqs_dot___hash_lambda40))

d_OP_toTypeEqs_dot___hash_lambda40 :: Curry_Prelude.OP_Tuple2 Curry_UnificationSpec.C_Term Curry_UnificationSpec.C_Term -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr
d_OP_toTypeEqs_dot___hash_lambda40 x1 x3500 = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> d_OP_eq_dot_eq (d_C_toTypeExpr x2 x3500) (d_C_toTypeExpr x3 x3500) x3500
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP_toTypeEqs_dot___hash_lambda40 x1002 x3500) (d_OP_toTypeEqs_dot___hash_lambda40 x1003 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP_toTypeEqs_dot___hash_lambda40 z x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP_toTypeEqs_dot___hash_lambda40 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple2 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_fromTypeExpr :: Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_UnificationSpec.C_Term
d_C_fromTypeExpr x1 x3500 = case x1 of
     (Curry_FlatCurry.C_TVar x2) -> Curry_UnificationSpec.C_TermVar x2
     (Curry_FlatCurry.C_TCons x3 x4) -> Curry_UnificationSpec.C_TermCons (d_C_fromQName x3 x3500) (Curry_Prelude.d_C_map d_C_fromTypeExpr x4 x3500)
     (Curry_FlatCurry.C_FuncType x5 x6) -> Curry_UnificationSpec.C_TermCons (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '-'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '>'#) Curry_Prelude.OP_List)) (Curry_Prelude.OP_Cons (d_C_fromTypeExpr x5 x3500) (Curry_Prelude.OP_Cons (d_C_fromTypeExpr x6 x3500) Curry_Prelude.OP_List))
     (Curry_FlatCurry.Choice_C_TypeExpr x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_fromTypeExpr x1002 x3500) (d_C_fromTypeExpr x1003 x3500)
     (Curry_FlatCurry.Choices_C_TypeExpr x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_fromTypeExpr z x3500) x1002
     (Curry_FlatCurry.Guard_C_TypeExpr x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_fromTypeExpr x1002) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_TypeExpr x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_toTypeExpr :: Curry_UnificationSpec.C_Term -> ConstStore -> Curry_FlatCurry.C_TypeExpr
d_C_toTypeExpr x1 x3500 = case x1 of
     (Curry_UnificationSpec.C_TermVar x2) -> Curry_FlatCurry.C_TVar x2
     (Curry_UnificationSpec.C_TermCons x3 x4) -> d_OP__case_6 x3 x4 (Curry_Prelude.d_OP_eq_eq x3 (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '-'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '>'#) Curry_Prelude.OP_List)) x3500) x3500
     (Curry_UnificationSpec.Choice_C_Term x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_toTypeExpr x1002 x3500) (d_C_toTypeExpr x1003 x3500)
     (Curry_UnificationSpec.Choices_C_Term x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_toTypeExpr z x3500) x1002
     (Curry_UnificationSpec.Guard_C_Term x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_toTypeExpr x1002) $! (addCs x1001 x3500))
     (Curry_UnificationSpec.Fail_C_Term x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_fromQName :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_fromQName x1 x3500 = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ';'#) Curry_Prelude.OP_List) x3 x3500) x3500
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_fromQName x1002 x3500) (d_C_fromQName x1003 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_fromQName z x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_fromQName x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple2 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_toQName :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
d_C_toQName x1 x3500 = let
     x2 = d_C_splitFirst x1 (Curry_Prelude.C_Char ';'#) x3500
      in (Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_C_fst x2 x3500) (Curry_Prelude.d_C_snd x2 x3500))

d_C_splitFirst :: Curry_Prelude.Curry t0 => Curry_Prelude.OP_List t0 -> t0 -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0)
d_C_splitFirst x1 x2 x3500 = case x1 of
     Curry_Prelude.OP_List -> Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_List Curry_Prelude.OP_List
     (Curry_Prelude.OP_Cons x3 x4) -> let
          x5 = d_C_splitFirst x4 x2 x3500
           in (d_OP__case_4 x2 x3 x5 x4 (Curry_Prelude.d_OP_eq_eq x3 x2 x3500) x3500)
     (Curry_Prelude.Choice_OP_List x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_splitFirst x1002 x2 x3500) (d_C_splitFirst x1003 x2 x3500)
     (Curry_Prelude.Choices_OP_List x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_splitFirst z x2 x3500) x1002
     (Curry_Prelude.Guard_OP_List x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_splitFirst x1002 x2) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_List x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_showUnificationError :: Curry_UnificationSpec.C_UnificationError -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showUnificationError x1 x3500 = case x1 of
     (Curry_UnificationSpec.C_Clash x2 x3) -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'C'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 's'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ':'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List))))))) (Curry_Prelude.d_OP_plus_plus (d_C_showTypeExpr (d_C_toTypeExpr x2 x3500) x3500) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '='#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List))) (d_C_showTypeExpr (d_C_toTypeExpr x3 x3500) x3500) x3500) x3500) x3500
     (Curry_UnificationSpec.C_OccurCheck x4 x5) -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'O'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'C'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'k'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ':'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'V'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'b'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List))))))))))))))))))))) (Curry_Prelude.d_OP_plus_plus (d_C_showTypeExpr (d_C_toTypeExpr (Curry_UnificationSpec.C_TermVar x4) x3500) x3500) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 's'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List))))))))))) (d_C_showTypeExpr (d_C_toTypeExpr x5 x3500) x3500) x3500) x3500) x3500
     (Curry_UnificationSpec.Choice_C_UnificationError x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_showUnificationError x1002 x3500) (d_C_showUnificationError x1003 x3500)
     (Curry_UnificationSpec.Choices_C_UnificationError x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_showUnificationError z x3500) x1002
     (Curry_UnificationSpec.Guard_C_UnificationError x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_showUnificationError x1002) $! (addCs x1001 x3500))
     (Curry_UnificationSpec.Fail_C_UnificationError x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_showTypeExpr :: Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showTypeExpr x1 x3500 = case x1 of
     (Curry_FlatCurry.C_TVar x2) -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '('#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'T'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'V'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List)))))) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_show x2 x3500) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ')'#) Curry_Prelude.OP_List) x3500) x3500
     (Curry_FlatCurry.C_TCons x3 x4) -> d_OP__case_2 x4 x3 x3500
     (Curry_FlatCurry.C_FuncType x7 x8) -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '('#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'F'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'T'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'y'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'p'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List)))))))))) (Curry_Prelude.d_OP_plus_plus (d_C_showTypeExpr x7 x3500) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ','#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List)) (Curry_Prelude.d_OP_plus_plus (d_C_showTypeExpr x8 x3500) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ')'#) Curry_Prelude.OP_List) x3500) x3500) x3500) x3500
     (Curry_FlatCurry.Choice_C_TypeExpr x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_showTypeExpr x1002 x3500) (d_C_showTypeExpr x1003 x3500)
     (Curry_FlatCurry.Choices_C_TypeExpr x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_showTypeExpr z x3500) x1002
     (Curry_FlatCurry.Guard_C_TypeExpr x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_showTypeExpr x1002) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_TypeExpr x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_normFunc :: Curry_Prelude.Curry t0 => Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr -> ConstStore -> t0 -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) t0)
d_C_normFunc x1 x3500 = case x1 of
     (Curry_AnnotatedFlatCurry.C_AFunc x2 x3 x4 x5 x6) -> let
          x7 = Curry_ErrorState.d_C_liftES2 (acceptCs (acceptCs id) (Curry_AnnotatedFlatCurry.C_AFunc x2 x3 x4)) (d_C_normType x5 x3500) (d_C_normRule x6 x3500) x3500
           in (d_OP__case_1 x7 x2 (Curry_ErrorState.d_C_evalES x7 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Int 0#) (Curry_FiniteMap.d_C_emptyFM (acceptCs id Curry_Prelude.d_OP_lt) x3500)) x3500) x3500)
     (Curry_AnnotatedFlatCurry.Choice_C_AFuncDecl x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_normFunc x1002 x3500) (d_C_normFunc x1003 x3500)
     (Curry_AnnotatedFlatCurry.Choices_C_AFuncDecl x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_normFunc z x3500) x1002
     (Curry_AnnotatedFlatCurry.Guard_C_AFuncDecl x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_normFunc x1002) $! (addCs x1001 x3500))
     (Curry_AnnotatedFlatCurry.Fail_C_AFuncDecl x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_C_normFunc :: Curry_Prelude.Curry t0 => Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func t0 (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) t0))
nd_C_normFunc x1 x3000 x3500 = case x1 of
     (Curry_AnnotatedFlatCurry.C_AFunc x2 x3 x4 x5 x6) -> let
          x2010 = x3000
           in (seq x2010 (let
               x2003 = leftSupply x2010
               x2009 = rightSupply x2010
                in (seq x2003 (seq x2009 (let
                    x7 = let
                         x2002 = leftSupply x2003
                         x2004 = rightSupply x2003
                          in (seq x2002 (seq x2004 (let
                              x2000 = leftSupply x2004
                              x2001 = rightSupply x2004
                               in (seq x2000 (seq x2001 (Curry_ErrorState.nd_C_liftES2 (wrapDX (wrapDX id) (acceptCs (acceptCs id) (Curry_AnnotatedFlatCurry.C_AFunc x2 x3 x4))) (nd_C_normType x5 x2000 x3500) (nd_C_normRule x6 x2001 x3500) x2002 x3500))))))
                     in (let
                         x2008 = leftSupply x2009
                         x2007 = rightSupply x2009
                          in (seq x2008 (seq x2007 (nd_OP__case_1 x7 x2 (let
                              x2006 = leftSupply x2007
                              x2005 = rightSupply x2007
                               in (seq x2006 (seq x2005 (Curry_ErrorState.nd_C_evalES x7 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.C_Int 0#) (Curry_FiniteMap.nd_C_emptyFM (wrapDX (wrapDX id) (acceptCs id Curry_Prelude.d_OP_lt)) x2005 x3500)) x2006 x3500)))) x2008 x3500)))))))))
     (Curry_AnnotatedFlatCurry.Choice_C_AFuncDecl x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_C_normFunc x1002 x3000 x3500) (nd_C_normFunc x1003 x3000 x3500)
     (Curry_AnnotatedFlatCurry.Choices_C_AFuncDecl x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_C_normFunc z x3000 x3500) x1002
     (Curry_AnnotatedFlatCurry.Guard_C_AFuncDecl x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_C_normFunc x1002 x3000) $! (addCs x1001 x3500))
     (Curry_AnnotatedFlatCurry.Fail_C_AFuncDecl x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_normType :: Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> ConstStore -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_C_normType x1 x3500 = case x1 of
     (Curry_FlatCurry.C_TVar x2) -> Curry_ErrorState.d_OP_gt_plus_eq Curry_ErrorState.d_C_gets (d_OP_normType_dot___hash_lambda42 x2)
     (Curry_FlatCurry.C_TCons x3 x4) -> Curry_ErrorState.d_C_liftES (acceptCs id (Curry_FlatCurry.C_TCons x3)) (Curry_ErrorState.d_C_mapES d_C_normType x4 x3500) x3500
     (Curry_FlatCurry.C_FuncType x5 x6) -> Curry_ErrorState.d_C_liftES2 (acceptCs (acceptCs id) Curry_FlatCurry.C_FuncType) (d_C_normType x5 x3500) (d_C_normType x6 x3500) x3500
     (Curry_FlatCurry.Choice_C_TypeExpr x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_normType x1002 x3500) (d_C_normType x1003 x3500)
     (Curry_FlatCurry.Choices_C_TypeExpr x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_normType z x3500) x1002
     (Curry_FlatCurry.Guard_C_TypeExpr x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_normType x1002) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_TypeExpr x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_C_normType :: Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_C_normType x1 x3000 x3500 = case x1 of
     (Curry_FlatCurry.C_TVar x2) -> wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (wrapDX id Curry_ErrorState.d_C_gets) (wrapNX id (nd_OP_normType_dot___hash_lambda42 x2)))
     (Curry_FlatCurry.C_TCons x3 x4) -> let
          x2002 = x3000
           in (seq x2002 (let
               x2001 = leftSupply x2002
               x2000 = rightSupply x2002
                in (seq x2001 (seq x2000 (Curry_ErrorState.nd_C_liftES (wrapDX id (acceptCs id (Curry_FlatCurry.C_TCons x3))) (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_normType) x4 x2000 x3500) x2001 x3500)))))
     (Curry_FlatCurry.C_FuncType x5 x6) -> let
          x2003 = x3000
           in (seq x2003 (let
               x2002 = leftSupply x2003
               x2004 = rightSupply x2003
                in (seq x2002 (seq x2004 (let
                    x2000 = leftSupply x2004
                    x2001 = rightSupply x2004
                     in (seq x2000 (seq x2001 (Curry_ErrorState.nd_C_liftES2 (wrapDX (wrapDX id) (acceptCs (acceptCs id) Curry_FlatCurry.C_FuncType)) (nd_C_normType x5 x2000 x3500) (nd_C_normType x6 x2001 x3500) x2002 x3500))))))))
     (Curry_FlatCurry.Choice_C_TypeExpr x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_C_normType x1002 x3000 x3500) (nd_C_normType x1003 x3000 x3500)
     (Curry_FlatCurry.Choices_C_TypeExpr x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_C_normType z x3000 x3500) x1002
     (Curry_FlatCurry.Guard_C_TypeExpr x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_C_normType x1002 x3000) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_TypeExpr x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP_normType_dot___hash_lambda42 :: Curry_Prelude.Curry t0 => Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> ConstStore -> Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_OP_normType_dot___hash_lambda42 x1 x2 x3500 = case x2 of
     (Curry_Prelude.OP_Tuple2 x3 x4) -> d_OP__case_0 x1 x4 x3 (Curry_FiniteMap.d_C_lookupFM x4 x1 x3500) x3500
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP_normType_dot___hash_lambda42 x1 x1002 x3500) (d_OP_normType_dot___hash_lambda42 x1 x1003 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP_normType_dot___hash_lambda42 x1 z x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP_normType_dot___hash_lambda42 x1 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple2 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_OP_normType_dot___hash_lambda42 :: Curry_Prelude.Curry t0 => Curry_Prelude.C_Int -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_OP_normType_dot___hash_lambda42 x1 x2 x3000 x3500 = case x2 of
     (Curry_Prelude.OP_Tuple2 x3 x4) -> let
          x2002 = x3000
           in (seq x2002 (let
               x2001 = leftSupply x2002
               x2000 = rightSupply x2002
                in (seq x2001 (seq x2000 (nd_OP__case_0 x1 x4 x3 (Curry_FiniteMap.nd_C_lookupFM x4 x1 x2000 x3500) x2001 x3500)))))
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_OP_normType_dot___hash_lambda42 x1 x1002 x3000 x3500) (nd_OP_normType_dot___hash_lambda42 x1 x1003 x3000 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_OP_normType_dot___hash_lambda42 x1 z x3000 x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_OP_normType_dot___hash_lambda42 x1 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple2 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_normRule :: Curry_AnnotatedFlatCurry.C_ARule Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> ConstStore -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_ARule Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_C_normRule x1 x3500 = case x1 of
     (Curry_AnnotatedFlatCurry.C_ARule x2 x3 x4) -> Curry_ErrorState.d_C_liftES3 (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_ARule) (d_C_normType x2 x3500) (Curry_ErrorState.d_C_mapES d_C_normSnd x3 x3500) (d_C_normExpr x4 x3500) x3500
     (Curry_AnnotatedFlatCurry.C_AExternal x5 x6) -> Curry_ErrorState.d_C_liftES (d_OP_normRule_dot___hash_lambda44 x6) (d_C_normType x5 x3500) x3500
     (Curry_AnnotatedFlatCurry.Choice_C_ARule x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_normRule x1002 x3500) (d_C_normRule x1003 x3500)
     (Curry_AnnotatedFlatCurry.Choices_C_ARule x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_normRule z x3500) x1002
     (Curry_AnnotatedFlatCurry.Guard_C_ARule x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_normRule x1002) $! (addCs x1001 x3500))
     (Curry_AnnotatedFlatCurry.Fail_C_ARule x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_C_normRule :: Curry_AnnotatedFlatCurry.C_ARule Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_ARule Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_C_normRule x1 x3000 x3500 = case x1 of
     (Curry_AnnotatedFlatCurry.C_ARule x2 x3 x4) -> let
          x2004 = x3000
           in (seq x2004 (let
               x2005 = leftSupply x2004
               x2006 = rightSupply x2004
                in (seq x2005 (seq x2006 (let
                    x2003 = leftSupply x2005
                    x2000 = rightSupply x2005
                     in (seq x2003 (seq x2000 (let
                         x2001 = leftSupply x2006
                         x2002 = rightSupply x2006
                          in (seq x2001 (seq x2002 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_ARule)) (nd_C_normType x2 x2000 x3500) (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_normSnd) x3 x2001 x3500) (nd_C_normExpr x4 x2002 x3500) x2003 x3500)))))))))))
     (Curry_AnnotatedFlatCurry.C_AExternal x5 x6) -> let
          x2002 = x3000
           in (seq x2002 (let
               x2001 = leftSupply x2002
               x2000 = rightSupply x2002
                in (seq x2001 (seq x2000 (Curry_ErrorState.nd_C_liftES (wrapDX id (d_OP_normRule_dot___hash_lambda44 x6)) (nd_C_normType x5 x2000 x3500) x2001 x3500)))))
     (Curry_AnnotatedFlatCurry.Choice_C_ARule x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_C_normRule x1002 x3000 x3500) (nd_C_normRule x1003 x3000 x3500)
     (Curry_AnnotatedFlatCurry.Choices_C_ARule x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_C_normRule z x3000 x3500) x1002
     (Curry_AnnotatedFlatCurry.Guard_C_ARule x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_C_normRule x1002 x3000) $! (addCs x1001 x3500))
     (Curry_AnnotatedFlatCurry.Fail_C_ARule x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP_normRule_dot___hash_lambda44 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_AnnotatedFlatCurry.C_ARule Curry_FlatCurry.C_TypeExpr
d_OP_normRule_dot___hash_lambda44 x1 x2 x3500 = Curry_AnnotatedFlatCurry.C_AExternal x2 x1

d_C_normExpr :: Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> ConstStore -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_C_normExpr x1 x3500 = case x1 of
     (Curry_AnnotatedFlatCurry.C_AVar x2 x3) -> Curry_ErrorState.d_C_liftES (d_OP_normExpr_dot___hash_lambda45 x3) (d_C_normType x2 x3500) x3500
     (Curry_AnnotatedFlatCurry.C_ALit x4 x5) -> Curry_ErrorState.d_C_liftES (d_OP_normExpr_dot___hash_lambda46 x5) (d_C_normType x4 x3500) x3500
     (Curry_AnnotatedFlatCurry.C_AComb x6 x7 x8 x9) -> Curry_ErrorState.d_C_liftES3 (d_OP_normExpr_dot___hash_lambda47 x7) (d_C_normType x6 x3500) (d_C_normSnd x8 x3500) (Curry_ErrorState.d_C_mapES d_C_normExpr x9 x3500) x3500
     (Curry_AnnotatedFlatCurry.C_ALet x10 x11 x12) -> Curry_ErrorState.d_C_liftES3 (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_ALet) (d_C_normType x10 x3500) (Curry_ErrorState.d_C_mapES d_OP_normExpr_dot_normBinding_dot_383 x11 x3500) (d_C_normExpr x12 x3500) x3500
     (Curry_AnnotatedFlatCurry.C_AOr x13 x14 x15) -> Curry_ErrorState.d_C_liftES3 (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_AOr) (d_C_normType x13 x3500) (d_C_normExpr x14 x3500) (d_C_normExpr x15 x3500) x3500
     (Curry_AnnotatedFlatCurry.C_ACase x16 x17 x18 x19) -> Curry_ErrorState.d_C_liftES3 (d_OP_normExpr_dot___hash_lambda49 x17) (d_C_normType x16 x3500) (d_C_normExpr x18 x3500) (Curry_ErrorState.d_C_mapES d_C_normBranch x19 x3500) x3500
     (Curry_AnnotatedFlatCurry.C_AFree x20 x21 x22) -> Curry_ErrorState.d_C_liftES3 (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_AFree) (d_C_normType x20 x3500) (Curry_ErrorState.d_C_mapES d_C_normSnd x21 x3500) (d_C_normExpr x22 x3500) x3500
     (Curry_AnnotatedFlatCurry.C_ATyped x23 x24 x25) -> Curry_ErrorState.d_C_liftES3 (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_ATyped) (d_C_normType x23 x3500) (d_C_normExpr x24 x3500) (d_C_normType x25 x3500) x3500
     (Curry_AnnotatedFlatCurry.Choice_C_AExpr x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_normExpr x1002 x3500) (d_C_normExpr x1003 x3500)
     (Curry_AnnotatedFlatCurry.Choices_C_AExpr x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_normExpr z x3500) x1002
     (Curry_AnnotatedFlatCurry.Guard_C_AExpr x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_normExpr x1002) $! (addCs x1001 x3500))
     (Curry_AnnotatedFlatCurry.Fail_C_AExpr x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_C_normExpr :: Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_C_normExpr x1 x3000 x3500 = case x1 of
     (Curry_AnnotatedFlatCurry.C_AVar x2 x3) -> let
          x2002 = x3000
           in (seq x2002 (let
               x2001 = leftSupply x2002
               x2000 = rightSupply x2002
                in (seq x2001 (seq x2000 (Curry_ErrorState.nd_C_liftES (wrapDX id (d_OP_normExpr_dot___hash_lambda45 x3)) (nd_C_normType x2 x2000 x3500) x2001 x3500)))))
     (Curry_AnnotatedFlatCurry.C_ALit x4 x5) -> let
          x2002 = x3000
           in (seq x2002 (let
               x2001 = leftSupply x2002
               x2000 = rightSupply x2002
                in (seq x2001 (seq x2000 (Curry_ErrorState.nd_C_liftES (wrapDX id (d_OP_normExpr_dot___hash_lambda46 x5)) (nd_C_normType x4 x2000 x3500) x2001 x3500)))))
     (Curry_AnnotatedFlatCurry.C_AComb x6 x7 x8 x9) -> let
          x2004 = x3000
           in (seq x2004 (let
               x2005 = leftSupply x2004
               x2006 = rightSupply x2004
                in (seq x2005 (seq x2006 (let
                    x2003 = leftSupply x2005
                    x2000 = rightSupply x2005
                     in (seq x2003 (seq x2000 (let
                         x2001 = leftSupply x2006
                         x2002 = rightSupply x2006
                          in (seq x2001 (seq x2002 (Curry_ErrorState.nd_C_liftES3 (wrapNX id (nd_OP_normExpr_dot___hash_lambda47 x7)) (nd_C_normType x6 x2000 x3500) (nd_C_normSnd x8 x2001 x3500) (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_normExpr) x9 x2002 x3500) x2003 x3500)))))))))))
     (Curry_AnnotatedFlatCurry.C_ALet x10 x11 x12) -> let
          x2004 = x3000
           in (seq x2004 (let
               x2005 = leftSupply x2004
               x2006 = rightSupply x2004
                in (seq x2005 (seq x2006 (let
                    x2003 = leftSupply x2005
                    x2000 = rightSupply x2005
                     in (seq x2003 (seq x2000 (let
                         x2001 = leftSupply x2006
                         x2002 = rightSupply x2006
                          in (seq x2001 (seq x2002 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_ALet)) (nd_C_normType x10 x2000 x3500) (Curry_ErrorState.nd_C_mapES (wrapNX id nd_OP_normExpr_dot_normBinding_dot_383) x11 x2001 x3500) (nd_C_normExpr x12 x2002 x3500) x2003 x3500)))))))))))
     (Curry_AnnotatedFlatCurry.C_AOr x13 x14 x15) -> let
          x2004 = x3000
           in (seq x2004 (let
               x2005 = leftSupply x2004
               x2006 = rightSupply x2004
                in (seq x2005 (seq x2006 (let
                    x2003 = leftSupply x2005
                    x2000 = rightSupply x2005
                     in (seq x2003 (seq x2000 (let
                         x2001 = leftSupply x2006
                         x2002 = rightSupply x2006
                          in (seq x2001 (seq x2002 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_AOr)) (nd_C_normType x13 x2000 x3500) (nd_C_normExpr x14 x2001 x3500) (nd_C_normExpr x15 x2002 x3500) x2003 x3500)))))))))))
     (Curry_AnnotatedFlatCurry.C_ACase x16 x17 x18 x19) -> let
          x2004 = x3000
           in (seq x2004 (let
               x2005 = leftSupply x2004
               x2006 = rightSupply x2004
                in (seq x2005 (seq x2006 (let
                    x2003 = leftSupply x2005
                    x2000 = rightSupply x2005
                     in (seq x2003 (seq x2000 (let
                         x2001 = leftSupply x2006
                         x2002 = rightSupply x2006
                          in (seq x2001 (seq x2002 (Curry_ErrorState.nd_C_liftES3 (wrapNX id (nd_OP_normExpr_dot___hash_lambda49 x17)) (nd_C_normType x16 x2000 x3500) (nd_C_normExpr x18 x2001 x3500) (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_normBranch) x19 x2002 x3500) x2003 x3500)))))))))))
     (Curry_AnnotatedFlatCurry.C_AFree x20 x21 x22) -> let
          x2004 = x3000
           in (seq x2004 (let
               x2005 = leftSupply x2004
               x2006 = rightSupply x2004
                in (seq x2005 (seq x2006 (let
                    x2003 = leftSupply x2005
                    x2000 = rightSupply x2005
                     in (seq x2003 (seq x2000 (let
                         x2001 = leftSupply x2006
                         x2002 = rightSupply x2006
                          in (seq x2001 (seq x2002 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_AFree)) (nd_C_normType x20 x2000 x3500) (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_normSnd) x21 x2001 x3500) (nd_C_normExpr x22 x2002 x3500) x2003 x3500)))))))))))
     (Curry_AnnotatedFlatCurry.C_ATyped x23 x24 x25) -> let
          x2004 = x3000
           in (seq x2004 (let
               x2005 = leftSupply x2004
               x2006 = rightSupply x2004
                in (seq x2005 (seq x2006 (let
                    x2003 = leftSupply x2005
                    x2000 = rightSupply x2005
                     in (seq x2003 (seq x2000 (let
                         x2001 = leftSupply x2006
                         x2002 = rightSupply x2006
                          in (seq x2001 (seq x2002 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_ATyped)) (nd_C_normType x23 x2000 x3500) (nd_C_normExpr x24 x2001 x3500) (nd_C_normType x25 x2002 x3500) x2003 x3500)))))))))))
     (Curry_AnnotatedFlatCurry.Choice_C_AExpr x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_C_normExpr x1002 x3000 x3500) (nd_C_normExpr x1003 x3000 x3500)
     (Curry_AnnotatedFlatCurry.Choices_C_AExpr x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_C_normExpr z x3000 x3500) x1002
     (Curry_AnnotatedFlatCurry.Guard_C_AExpr x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_C_normExpr x1002 x3000) $! (addCs x1001 x3500))
     (Curry_AnnotatedFlatCurry.Fail_C_AExpr x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP_normExpr_dot___hash_lambda45 :: Curry_Prelude.C_Int -> Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr
d_OP_normExpr_dot___hash_lambda45 x1 x2 x3500 = Curry_AnnotatedFlatCurry.C_AVar x2 x1

d_OP_normExpr_dot___hash_lambda46 :: Curry_FlatCurry.C_Literal -> Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr
d_OP_normExpr_dot___hash_lambda46 x1 x2 x3500 = Curry_AnnotatedFlatCurry.C_ALit x2 x1

d_OP_normExpr_dot___hash_lambda47 :: Curry_FlatCurry.C_CombType -> Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_List (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr
d_OP_normExpr_dot___hash_lambda47 x1 x2 x3500 = acceptCs (acceptCs id) (Curry_AnnotatedFlatCurry.C_AComb x2 x1)

nd_OP_normExpr_dot___hash_lambda47 :: Curry_FlatCurry.C_CombType -> Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) (Func (Curry_Prelude.OP_List (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr)) (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr))
nd_OP_normExpr_dot___hash_lambda47 x1 x2 x3000 x3500 = wrapDX (wrapDX id) (acceptCs (acceptCs id) (Curry_AnnotatedFlatCurry.C_AComb x2 x1))

d_OP_normExpr_dot_normBinding_dot_383 :: Curry_Prelude.Curry t0 => Curry_Prelude.OP_Tuple2 t0 (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> ConstStore -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0 (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_OP_normExpr_dot_normBinding_dot_383 x1 x3500 = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> Curry_ErrorState.d_OP_gt_plus_eq (d_C_normExpr x3 x3500) (d_OP_normExpr_dot_normBinding_dot_383_dot___hash_lambda48 x2)
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP_normExpr_dot_normBinding_dot_383 x1002 x3500) (d_OP_normExpr_dot_normBinding_dot_383 x1003 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP_normExpr_dot_normBinding_dot_383 z x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP_normExpr_dot_normBinding_dot_383 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple2 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_OP_normExpr_dot_normBinding_dot_383 :: Curry_Prelude.Curry t0 => Curry_Prelude.OP_Tuple2 t0 (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0 (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_OP_normExpr_dot_normBinding_dot_383 x1 x3000 x3500 = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> let
          x2000 = x3000
           in (seq x2000 (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_normExpr x3 x2000 x3500) (wrapNX id (nd_OP_normExpr_dot_normBinding_dot_383_dot___hash_lambda48 x2)))))
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_OP_normExpr_dot_normBinding_dot_383 x1002 x3000 x3500) (nd_OP_normExpr_dot_normBinding_dot_383 x1003 x3000 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_OP_normExpr_dot_normBinding_dot_383 z x3000 x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_OP_normExpr_dot_normBinding_dot_383 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple2 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP_normExpr_dot_normBinding_dot_383_dot___hash_lambda48 :: (Curry_Prelude.Curry t2,Curry_Prelude.Curry t0,Curry_Prelude.Curry t1) => t0 -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr -> ConstStore -> t1 -> ConstStore -> Curry_Prelude.C_Either t2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0 (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr)) t1)
d_OP_normExpr_dot_normBinding_dot_383_dot___hash_lambda48 x1 x2 x3500 = Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 x1 x2)

nd_OP_normExpr_dot_normBinding_dot_383_dot___hash_lambda48 :: (Curry_Prelude.Curry t2,Curry_Prelude.Curry t0,Curry_Prelude.Curry t1) => t0 -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func t1 (Curry_Prelude.C_Either t2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0 (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr)) t1))
nd_OP_normExpr_dot_normBinding_dot_383_dot___hash_lambda48 x1 x2 x3000 x3500 = wrapDX id (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 x1 x2))

d_OP_normExpr_dot___hash_lambda49 :: Curry_FlatCurry.C_CaseType -> Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_List (Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr
d_OP_normExpr_dot___hash_lambda49 x1 x2 x3500 = acceptCs (acceptCs id) (Curry_AnnotatedFlatCurry.C_ACase x2 x1)

nd_OP_normExpr_dot___hash_lambda49 :: Curry_FlatCurry.C_CaseType -> Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) (Func (Curry_Prelude.OP_List (Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr)) (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr))
nd_OP_normExpr_dot___hash_lambda49 x1 x2 x3000 x3500 = wrapDX (wrapDX id) (acceptCs (acceptCs id) (Curry_AnnotatedFlatCurry.C_ACase x2 x1))

d_C_normSnd :: Curry_Prelude.Curry t0 => Curry_Prelude.OP_Tuple2 t0 Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> ConstStore -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0 Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_C_normSnd x1 x3500 = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> Curry_ErrorState.d_OP_gt_plus_eq (d_C_normType x3 x3500) (d_OP_normSnd_dot___hash_lambda50 x2)
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_normSnd x1002 x3500) (d_C_normSnd x1003 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_normSnd z x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_normSnd x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple2 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_C_normSnd :: Curry_Prelude.Curry t0 => Curry_Prelude.OP_Tuple2 t0 Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0 Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_C_normSnd x1 x3000 x3500 = case x1 of
     (Curry_Prelude.OP_Tuple2 x2 x3) -> let
          x2000 = x3000
           in (seq x2000 (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_normType x3 x2000 x3500) (wrapNX id (nd_OP_normSnd_dot___hash_lambda50 x2)))))
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_C_normSnd x1002 x3000 x3500) (nd_C_normSnd x1003 x3000 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_C_normSnd z x3000 x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_C_normSnd x1002 x3000) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple2 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP_normSnd_dot___hash_lambda50 :: (Curry_Prelude.Curry t2,Curry_Prelude.Curry t0,Curry_Prelude.Curry t1) => t0 -> Curry_FlatCurry.C_TypeExpr -> ConstStore -> t1 -> ConstStore -> Curry_Prelude.C_Either t2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0 Curry_FlatCurry.C_TypeExpr) t1)
d_OP_normSnd_dot___hash_lambda50 x1 x2 x3500 = Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 x1 x2)

nd_OP_normSnd_dot___hash_lambda50 :: (Curry_Prelude.Curry t2,Curry_Prelude.Curry t0,Curry_Prelude.Curry t1) => t0 -> Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func t1 (Curry_Prelude.C_Either t2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 t0 Curry_FlatCurry.C_TypeExpr) t1))
nd_OP_normSnd_dot___hash_lambda50 x1 x2 x3000 x3500 = wrapDX id (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 x1 x2))

d_C_normBranch :: Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> ConstStore -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_C_normBranch x1 x3500 = case x1 of
     (Curry_AnnotatedFlatCurry.C_ABranch x2 x3) -> Curry_ErrorState.d_C_liftES2 (acceptCs (acceptCs id) Curry_AnnotatedFlatCurry.C_ABranch) (d_C_normPattern x2 x3500) (d_C_normExpr x3 x3500) x3500
     (Curry_AnnotatedFlatCurry.Choice_C_ABranchExpr x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_normBranch x1002 x3500) (d_C_normBranch x1003 x3500)
     (Curry_AnnotatedFlatCurry.Choices_C_ABranchExpr x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_normBranch z x3500) x1002
     (Curry_AnnotatedFlatCurry.Guard_C_ABranchExpr x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_normBranch x1002) $! (addCs x1001 x3500))
     (Curry_AnnotatedFlatCurry.Fail_C_ABranchExpr x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_C_normBranch :: Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_ABranchExpr Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_C_normBranch x1 x3000 x3500 = case x1 of
     (Curry_AnnotatedFlatCurry.C_ABranch x2 x3) -> let
          x2003 = x3000
           in (seq x2003 (let
               x2002 = leftSupply x2003
               x2004 = rightSupply x2003
                in (seq x2002 (seq x2004 (let
                    x2000 = leftSupply x2004
                    x2001 = rightSupply x2004
                     in (seq x2000 (seq x2001 (Curry_ErrorState.nd_C_liftES2 (wrapDX (wrapDX id) (acceptCs (acceptCs id) Curry_AnnotatedFlatCurry.C_ABranch)) (nd_C_normPattern x2 x2000 x3500) (nd_C_normExpr x3 x2001 x3500) x2002 x3500))))))))
     (Curry_AnnotatedFlatCurry.Choice_C_ABranchExpr x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_C_normBranch x1002 x3000 x3500) (nd_C_normBranch x1003 x3000 x3500)
     (Curry_AnnotatedFlatCurry.Choices_C_ABranchExpr x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_C_normBranch z x3000 x3500) x1002
     (Curry_AnnotatedFlatCurry.Guard_C_ABranchExpr x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_C_normBranch x1002 x3000) $! (addCs x1001 x3500))
     (Curry_AnnotatedFlatCurry.Fail_C_ABranchExpr x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_C_normPattern :: Curry_AnnotatedFlatCurry.C_APattern Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> ConstStore -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_APattern Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_C_normPattern x1 x3500 = case x1 of
     (Curry_AnnotatedFlatCurry.C_APattern x2 x3 x4) -> Curry_ErrorState.d_C_liftES3 (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_APattern) (d_C_normType x2 x3500) (d_C_normSnd x3 x3500) (Curry_ErrorState.d_C_mapES d_C_normSnd x4 x3500) x3500
     (Curry_AnnotatedFlatCurry.C_ALPattern x5 x6) -> Curry_ErrorState.d_C_liftES (d_OP_normPattern_dot___hash_lambda51 x6) (d_C_normType x5 x3500) x3500
     (Curry_AnnotatedFlatCurry.Choice_C_APattern x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_C_normPattern x1002 x3500) (d_C_normPattern x1003 x3500)
     (Curry_AnnotatedFlatCurry.Choices_C_APattern x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_C_normPattern z x3500) x1002
     (Curry_AnnotatedFlatCurry.Guard_C_APattern x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_C_normPattern x1002) $! (addCs x1001 x3500))
     (Curry_AnnotatedFlatCurry.Fail_C_APattern x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_C_normPattern :: Curry_AnnotatedFlatCurry.C_APattern Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_APattern Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_C_normPattern x1 x3000 x3500 = case x1 of
     (Curry_AnnotatedFlatCurry.C_APattern x2 x3 x4) -> let
          x2004 = x3000
           in (seq x2004 (let
               x2005 = leftSupply x2004
               x2006 = rightSupply x2004
                in (seq x2005 (seq x2006 (let
                    x2003 = leftSupply x2005
                    x2000 = rightSupply x2005
                     in (seq x2003 (seq x2000 (let
                         x2001 = leftSupply x2006
                         x2002 = rightSupply x2006
                          in (seq x2001 (seq x2002 (Curry_ErrorState.nd_C_liftES3 (wrapDX (wrapDX (wrapDX id)) (acceptCs (acceptCs (acceptCs id)) Curry_AnnotatedFlatCurry.C_APattern)) (nd_C_normType x2 x2000 x3500) (nd_C_normSnd x3 x2001 x3500) (Curry_ErrorState.nd_C_mapES (wrapNX id nd_C_normSnd) x4 x2002 x3500) x2003 x3500)))))))))))
     (Curry_AnnotatedFlatCurry.C_ALPattern x5 x6) -> let
          x2002 = x3000
           in (seq x2002 (let
               x2001 = leftSupply x2002
               x2000 = rightSupply x2002
                in (seq x2001 (seq x2000 (Curry_ErrorState.nd_C_liftES (wrapDX id (d_OP_normPattern_dot___hash_lambda51 x6)) (nd_C_normType x5 x2000 x3500) x2001 x3500)))))
     (Curry_AnnotatedFlatCurry.Choice_C_APattern x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_C_normPattern x1002 x3000 x3500) (nd_C_normPattern x1003 x3000 x3500)
     (Curry_AnnotatedFlatCurry.Choices_C_APattern x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_C_normPattern z x3000 x3500) x1002
     (Curry_AnnotatedFlatCurry.Guard_C_APattern x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_C_normPattern x1002 x3000) $! (addCs x1001 x3500))
     (Curry_AnnotatedFlatCurry.Fail_C_APattern x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP_normPattern_dot___hash_lambda51 :: Curry_FlatCurry.C_Literal -> Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_AnnotatedFlatCurry.C_APattern Curry_FlatCurry.C_TypeExpr
d_OP_normPattern_dot___hash_lambda51 x1 x2 x3500 = Curry_AnnotatedFlatCurry.C_ALPattern x2 x1

d_OP__case_0 :: Curry_Prelude.Curry t0 => Curry_Prelude.C_Int -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Curry_Prelude.C_Maybe Curry_Prelude.C_Int -> ConstStore -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> ConstStore -> Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))
d_OP__case_0 x1 x4 x3 x6 x3500 = case x6 of
     Curry_Prelude.C_Nothing -> Curry_ErrorState.d_OP_gt_plus (Curry_ErrorState.d_C_puts (Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_OP_plus x3 (Curry_Prelude.C_Int 1#) x3500) (Curry_FiniteMap.d_C_addToFM x4 x1 x3 x3500))) (Curry_ErrorState.d_C_returnES (Curry_FlatCurry.C_TVar x3)) x3500
     (Curry_Prelude.C_Just x5) -> Curry_ErrorState.d_C_returnES (Curry_FlatCurry.C_TVar x5)
     (Curry_Prelude.Choice_C_Maybe x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP__case_0 x1 x4 x3 x1002 x3500) (d_OP__case_0 x1 x4 x3 x1003 x3500)
     (Curry_Prelude.Choices_C_Maybe x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP__case_0 x1 x4 x3 z x3500) x1002
     (Curry_Prelude.Guard_C_Maybe x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP__case_0 x1 x4 x3 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_C_Maybe x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_OP__case_0 :: Curry_Prelude.Curry t0 => Curry_Prelude.C_Int -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> Curry_Prelude.C_Maybe Curry_Prelude.C_Int -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either t0 (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int))))
nd_OP__case_0 x1 x4 x3 x6 x3000 x3500 = case x6 of
     Curry_Prelude.C_Nothing -> let
          x2002 = x3000
           in (seq x2002 (let
               x2001 = leftSupply x2002
               x2000 = rightSupply x2002
                in (seq x2001 (seq x2000 (Curry_ErrorState.nd_OP_gt_plus (wrapDX id (Curry_ErrorState.d_C_puts (Curry_Prelude.OP_Tuple2 (Curry_Prelude.d_OP_plus x3 (Curry_Prelude.C_Int 1#) x3500) (Curry_FiniteMap.nd_C_addToFM x4 x1 x3 x2000 x3500)))) (wrapDX id (Curry_ErrorState.d_C_returnES (Curry_FlatCurry.C_TVar x3))) x2001 x3500)))))
     (Curry_Prelude.C_Just x5) -> wrapDX id (Curry_ErrorState.d_C_returnES (Curry_FlatCurry.C_TVar x5))
     (Curry_Prelude.Choice_C_Maybe x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_OP__case_0 x1 x4 x3 x1002 x3000 x3500) (nd_OP__case_0 x1 x4 x3 x1003 x3000 x3500)
     (Curry_Prelude.Choices_C_Maybe x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_OP__case_0 x1 x4 x3 z x3000 x3500) x1002
     (Curry_Prelude.Guard_C_Maybe x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_OP__case_0 x1 x4 x3 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_C_Maybe x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP__case_1 :: Curry_Prelude.Curry t0 => (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int) -> ConstStore -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) -> ConstStore -> t0 -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) t0)
d_OP__case_1 x7 x2 x10 x3500 = case x10 of
     (Curry_Prelude.C_Left x8) -> Curry_Prelude.d_OP_dollar (acceptCs id Curry_ErrorState.d_C_failES) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'N'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'm'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'z'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'f'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'f'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List)))))))))))))))))))))))))) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_show x2 x3500) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'f'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) Curry_Prelude.OP_List))))))) x3500) x3500) x3500
     (Curry_Prelude.C_Right x9) -> Curry_ErrorState.d_C_returnES x9
     (Curry_Prelude.Choice_C_Either x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP__case_1 x7 x2 x1002 x3500) (d_OP__case_1 x7 x2 x1003 x3500)
     (Curry_Prelude.Choices_C_Either x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP__case_1 x7 x2 z x3500) x1002
     (Curry_Prelude.Guard_C_Either x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP__case_1 x7 x2 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_C_Either x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_OP__case_1 :: Curry_Prelude.Curry t0 => Func (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)) (Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_Prelude.C_Int)))) -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Either Curry_Prelude.OP_Unit (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) -> IDSupply -> ConstStore -> Func t0 (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr) t0))
nd_OP__case_1 x7 x2 x10 x3000 x3500 = case x10 of
     (Curry_Prelude.C_Left x8) -> let
          x2000 = x3000
           in (seq x2000 (Curry_Prelude.nd_OP_dollar (wrapDX (wrapDX id) (acceptCs id Curry_ErrorState.d_C_failES)) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'N'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'm'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'z'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'f'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'f'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List)))))))))))))))))))))))))) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_show x2 x3500) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'f'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'a'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) Curry_Prelude.OP_List))))))) x3500) x3500) x2000 x3500))
     (Curry_Prelude.C_Right x9) -> wrapDX id (Curry_ErrorState.d_C_returnES x9)
     (Curry_Prelude.Choice_C_Either x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_OP__case_1 x7 x2 x1002 x3000 x3500) (nd_OP__case_1 x7 x2 x1003 x3000 x3500)
     (Curry_Prelude.Choices_C_Either x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_OP__case_1 x7 x2 z x3000 x3500) x1002
     (Curry_Prelude.Guard_C_Either x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_OP__case_1 x7 x2 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_C_Either x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP__case_2 :: Curry_Prelude.OP_List Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP__case_2 x4 x3 x3500 = case x3 of
     (Curry_Prelude.OP_Tuple2 x5 x6) -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '('#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'T'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'C'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 's'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '('#) Curry_Prelude.OP_List)))))))) (Curry_Prelude.d_OP_plus_plus x5 (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ','#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List)) (Curry_Prelude.d_OP_plus_plus x6 (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ')'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char '['#) Curry_Prelude.OP_List))) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_OP_dollar Curry_Prelude.d_C_concat (Curry_Prelude.d_C_map d_C_showTypeExpr x4 x3500) x3500) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ']'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ')'#) Curry_Prelude.OP_List)) x3500) x3500) x3500) x3500) x3500) x3500
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP__case_2 x4 x1002 x3500) (d_OP__case_2 x4 x1003 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP__case_2 x4 z x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP__case_2 x4 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple2 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP__case_4 :: Curry_Prelude.Curry t0 => t0 -> t0 -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0) -> Curry_Prelude.OP_List t0 -> Curry_Prelude.C_Bool -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0)
d_OP__case_4 x2 x3 x5 x4 x6 x3500 = case x6 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 Curry_Prelude.OP_List x4
     Curry_Prelude.C_False -> d_OP__case_3 x5 x3 (Curry_Prelude.d_C_otherwise x3500) x3500
     (Curry_Prelude.Choice_C_Bool x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP__case_4 x2 x3 x5 x4 x1002 x3500) (d_OP__case_4 x2 x3 x5 x4 x1003 x3500)
     (Curry_Prelude.Choices_C_Bool x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP__case_4 x2 x3 x5 x4 z x3500) x1002
     (Curry_Prelude.Guard_C_Bool x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP__case_4 x2 x3 x5 x4 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_C_Bool x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP__case_3 :: Curry_Prelude.Curry t0 => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0) -> t0 -> Curry_Prelude.C_Bool -> ConstStore -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0)
d_OP__case_3 x5 x3 x6 x3500 = case x6 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Cons x3 (Curry_Prelude.d_C_fst x5 x3500)) (Curry_Prelude.d_C_snd x5 x3500)
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed x3500
     (Curry_Prelude.Choice_C_Bool x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP__case_3 x5 x3 x1002 x3500) (d_OP__case_3 x5 x3 x1003 x3500)
     (Curry_Prelude.Choices_C_Bool x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP__case_3 x5 x3 z x3500) x1002
     (Curry_Prelude.Guard_C_Bool x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP__case_3 x5 x3 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_C_Bool x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP__case_6 :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_UnificationSpec.C_Term -> Curry_Prelude.C_Bool -> ConstStore -> Curry_FlatCurry.C_TypeExpr
d_OP__case_6 x3 x4 x5 x3500 = case x5 of
     Curry_Prelude.C_True -> Curry_FlatCurry.C_FuncType (d_C_toTypeExpr (Curry_Prelude.d_OP_bang_bang x4 (Curry_Prelude.C_Int 0#) x3500) x3500) (d_C_toTypeExpr (Curry_Prelude.d_OP_bang_bang x4 (Curry_Prelude.C_Int 1#) x3500) x3500)
     Curry_Prelude.C_False -> d_OP__case_5 x4 x3 (Curry_Prelude.d_C_otherwise x3500) x3500
     (Curry_Prelude.Choice_C_Bool x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP__case_6 x3 x4 x1002 x3500) (d_OP__case_6 x3 x4 x1003 x3500)
     (Curry_Prelude.Choices_C_Bool x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP__case_6 x3 x4 z x3500) x1002
     (Curry_Prelude.Guard_C_Bool x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP__case_6 x3 x4 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_C_Bool x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP__case_5 :: Curry_Prelude.OP_List Curry_UnificationSpec.C_Term -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> ConstStore -> Curry_FlatCurry.C_TypeExpr
d_OP__case_5 x4 x3 x5 x3500 = case x5 of
     Curry_Prelude.C_True -> Curry_FlatCurry.C_TCons (d_C_toQName x3 x3500) (Curry_Prelude.d_C_map d_C_toTypeExpr x4 x3500)
     Curry_Prelude.C_False -> Curry_Prelude.d_C_failed x3500
     (Curry_Prelude.Choice_C_Bool x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP__case_5 x4 x3 x1002 x3500) (d_OP__case_5 x4 x3 x1003 x3500)
     (Curry_Prelude.Choices_C_Bool x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP__case_5 x4 x3 z x3500) x1002
     (Curry_Prelude.Guard_C_Bool x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP__case_5 x4 x3 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_C_Bool x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP__case_7 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr) -> Curry_Prelude.C_Either Curry_UnificationSpec.C_UnificationError (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_UnificationSpec.C_Term) -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP__case_7 x1 x4 x3500 = case x4 of
     (Curry_Prelude.C_Left x2) -> Curry_Prelude.d_OP_dollar (acceptCs id Curry_ErrorState.d_C_failES) (d_C_showUnificationError x2 x3500) x3500
     (Curry_Prelude.C_Right x3) -> Curry_ErrorState.d_C_returnES (Curry_FiniteMap.d_C_mapFM d_OP_unification_dot___hash_lambda38 x3 x3500)
     (Curry_Prelude.Choice_C_Either x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP__case_7 x1 x1002 x3500) (d_OP__case_7 x1 x1003 x3500)
     (Curry_Prelude.Choices_C_Either x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP__case_7 x1 z x3500) x1002
     (Curry_Prelude.Guard_C_Either x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP__case_7 x1 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_C_Either x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_OP__case_7 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr) -> Curry_Prelude.C_Either Curry_UnificationSpec.C_UnificationError (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_UnificationSpec.C_Term) -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP__case_7 x1 x4 x3000 x3500 = case x4 of
     (Curry_Prelude.C_Left x2) -> let
          x2000 = x3000
           in (seq x2000 (Curry_Prelude.nd_OP_dollar (wrapDX (wrapDX id) (acceptCs id Curry_ErrorState.d_C_failES)) (d_C_showUnificationError x2 x3500) x2000 x3500))
     (Curry_Prelude.C_Right x3) -> let
          x2000 = x3000
           in (seq x2000 (wrapDX id (Curry_ErrorState.d_C_returnES (Curry_FiniteMap.nd_C_mapFM (wrapNX id nd_OP_unification_dot___hash_lambda38) x3 x2000 x3500))))
     (Curry_Prelude.Choice_C_Either x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_OP__case_7 x1 x1002 x3000 x3500) (nd_OP__case_7 x1 x1003 x3000 x3500)
     (Curry_Prelude.Choices_C_Either x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_OP__case_7 x1 z x3000 x3500) x1002
     (Curry_Prelude.Guard_C_Either x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_OP__case_7 x1 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_C_Either x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP__case_9 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_Prelude.C_Int -> Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.C_Maybe Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP__case_9 x1 x12 x11 x14 x3500 = case x14 of
     (Curry_Prelude.C_Just x13) -> Curry_ErrorState.d_C_returnES (d_OP__case_8 x13 x11 (Curry_Prelude.d_OP_eq_eq x11 x13 x3500) x3500)
     Curry_Prelude.C_Nothing -> Curry_ErrorState.d_C_returnES Curry_Prelude.OP_List
     (Curry_Prelude.Choice_C_Maybe x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP__case_9 x1 x12 x11 x1002 x3500) (d_OP__case_9 x1 x12 x11 x1003 x3500)
     (Curry_Prelude.Choices_C_Maybe x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP__case_9 x1 x12 x11 z x3500) x1002
     (Curry_Prelude.Guard_C_Maybe x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP__case_9 x1 x12 x11 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_C_Maybe x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_OP__case_9 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_Prelude.C_Int -> Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.C_Maybe Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP__case_9 x1 x12 x11 x14 x3000 x3500 = case x14 of
     (Curry_Prelude.C_Just x13) -> wrapDX id (Curry_ErrorState.d_C_returnES (d_OP__case_8 x13 x11 (Curry_Prelude.d_OP_eq_eq x11 x13 x3500) x3500))
     Curry_Prelude.C_Nothing -> wrapDX id (Curry_ErrorState.d_C_returnES Curry_Prelude.OP_List)
     (Curry_Prelude.Choice_C_Maybe x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_OP__case_9 x1 x12 x11 x1002 x3000 x3500) (nd_OP__case_9 x1 x12 x11 x1003 x3000 x3500)
     (Curry_Prelude.Choices_C_Maybe x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_OP__case_9 x1 x12 x11 z x3000 x3500) x1002
     (Curry_Prelude.Guard_C_Maybe x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_OP__case_9 x1 x12 x11 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_C_Maybe x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP__case_8 :: Curry_FlatCurry.C_TypeExpr -> Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.C_Bool -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)
d_OP__case_8 x13 x11 x14 x3500 = case x14 of
     Curry_Prelude.C_True -> Curry_Prelude.OP_List
     Curry_Prelude.C_False -> Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x11 x13 x3500) Curry_Prelude.OP_List
     (Curry_Prelude.Choice_C_Bool x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP__case_8 x13 x11 x1002 x3500) (d_OP__case_8 x13 x11 x1003 x3500)
     (Curry_Prelude.Choices_C_Bool x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP__case_8 x13 x11 z x3500) x1002
     (Curry_Prelude.Guard_C_Bool x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP__case_8 x13 x11 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_C_Bool x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP__case_10 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_FlatCurry.C_TypeExpr -> Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP__case_10 x5 x3 x1 x4 x3500 = case x4 of
     (Curry_Prelude.OP_Tuple2 x6 x7) -> Curry_Prelude.d_OP_dollar (acceptCs id Curry_ErrorState.d_C_returnES) (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 x3 x3500) (d_C_matchApp x3 x7 (Curry_Prelude.d_C_map Curry_Prelude.d_C_snd x5 x3500) x3500)) x3500
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP__case_10 x5 x3 x1 x1002 x3500) (d_OP__case_10 x5 x3 x1 x1003 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP__case_10 x5 x3 x1 z x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP__case_10 x5 x3 x1 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple2 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_OP__case_10 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_FlatCurry.C_TypeExpr -> Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP__case_10 x5 x3 x1 x4 x3000 x3500 = case x4 of
     (Curry_Prelude.OP_Tuple2 x6 x7) -> let
          x2002 = x3000
           in (seq x2002 (let
               x2001 = leftSupply x2002
               x2000 = rightSupply x2002
                in (seq x2001 (seq x2000 (Curry_Prelude.nd_OP_dollar (wrapDX (wrapDX id) (acceptCs id Curry_ErrorState.d_C_returnES)) (Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x1 x3 x3500) (d_C_matchApp x3 x7 (Curry_Prelude.nd_C_map (wrapDX id Curry_Prelude.d_C_snd) x5 x2000 x3500) x3500)) x2001 x3500)))))
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_OP__case_10 x5 x3 x1 x1002 x3000 x3500) (nd_OP__case_10 x5 x3 x1 x1003 x3000 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_OP__case_10 x5 x3 x1 z x3000 x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_OP__case_10 x5 x3 x1 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple2 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP__case_11 :: Curry_Prelude.OP_List (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) -> Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP__case_11 x9 x6 x8 x3500 = case x8 of
     (Curry_Prelude.OP_Tuple2 x10 x11) -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (d_OP_plus_plus_eq x3500) (Curry_ErrorState.d_C_returnES (Curry_Prelude.d_OP_dollar (d_C_matchApp x6 x11) (Curry_Prelude.d_C_map (d_C_exprType x3500) x9 x3500) x3500)) x3500) (Curry_ErrorState.d_C_concatMapES d_C_inferExpr x9 x3500) x3500
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP__case_11 x9 x6 x1002 x3500) (d_OP__case_11 x9 x6 x1003 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP__case_11 x9 x6 z x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP__case_11 x9 x6 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple2 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_OP__case_11 :: Curry_Prelude.OP_List (Curry_AnnotatedFlatCurry.C_AExpr Curry_FlatCurry.C_TypeExpr) -> Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP__case_11 x9 x6 x8 x3000 x3500 = case x8 of
     (Curry_Prelude.OP_Tuple2 x10 x11) -> let
          x2011 = x3000
           in (seq x2011 (let
               x2010 = leftSupply x2011
               x2012 = rightSupply x2011
                in (seq x2010 (seq x2012 (let
                    x2007 = leftSupply x2012
                    x2009 = rightSupply x2012
                     in (seq x2007 (seq x2009 (Curry_Prelude.nd_C_apply (let
                         x2006 = leftSupply x2007
                         x2008 = rightSupply x2007
                          in (seq x2006 (seq x2008 (let
                              x2000 = leftSupply x2008
                              x2005 = rightSupply x2008
                               in (seq x2000 (seq x2005 (Curry_Prelude.nd_C_apply (nd_OP_plus_plus_eq x2000 x3500) (wrapDX id (Curry_ErrorState.d_C_returnES (let
                                   x2004 = leftSupply x2005
                                   x2003 = rightSupply x2005
                                    in (seq x2004 (seq x2003 (Curry_Prelude.nd_OP_dollar (wrapDX id (d_C_matchApp x6 x11)) (let
                                        x2002 = leftSupply x2003
                                        x2001 = rightSupply x2003
                                         in (seq x2002 (seq x2001 (Curry_Prelude.nd_C_map (nd_C_exprType x2001 x3500) x9 x2002 x3500)))) x2004 x3500)))))) x2006 x3500))))))) (Curry_ErrorState.nd_C_concatMapES (wrapNX id nd_C_inferExpr) x9 x2009 x3500) x2010 x3500))))))))
     (Curry_Prelude.Choice_OP_Tuple2 x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_OP__case_11 x9 x6 x1002 x3000 x3500) (nd_OP__case_11 x9 x6 x1003 x3000 x3500)
     (Curry_Prelude.Choices_OP_Tuple2 x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_OP__case_11 x9 x6 z x3000 x3500) x1002
     (Curry_Prelude.Guard_OP_Tuple2 x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_OP__case_11 x9 x6 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_OP_Tuple2 x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP__case_12 :: Curry_Prelude.OP_List Curry_FlatCurry.C_TypeExpr -> Curry_FlatCurry.C_TypeExpr -> Curry_FlatCurry.C_TypeExpr -> Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_FlatCurry.C_TypeExpr Curry_FlatCurry.C_TypeExpr)
d_OP__case_12 x5 x1 x4 x2 x3500 = case x2 of
     (Curry_FlatCurry.C_FuncType x6 x7) -> Curry_Prelude.OP_Cons (d_OP_eq_dot_eq x4 x6 x3500) (d_C_matchApp x1 x7 x5 x3500)
     (Curry_FlatCurry.Choice_C_TypeExpr x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP__case_12 x5 x1 x4 x1002 x3500) (d_OP__case_12 x5 x1 x4 x1003 x3500)
     (Curry_FlatCurry.Choices_C_TypeExpr x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP__case_12 x5 x1 x4 z x3500) x1002
     (Curry_FlatCurry.Guard_C_TypeExpr x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP__case_12 x5 x1 x4 x1002) $! (addCs x1001 x3500))
     (Curry_FlatCurry.Fail_C_TypeExpr x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP__case_13 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_Prelude.C_Int -> Curry_Prelude.C_Maybe Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP__case_13 x1 x3 x5 x3500 = case x5 of
     (Curry_Prelude.C_Just x4) -> Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 x1 x4)
     Curry_Prelude.C_Nothing -> Curry_ErrorState.d_OP_gt_plus_eq (d_C_nextTVar x3500) (d_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda17 x3 x1)
     (Curry_Prelude.Choice_C_Maybe x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP__case_13 x1 x3 x1002 x3500) (d_OP__case_13 x1 x3 x1003 x3500)
     (Curry_Prelude.Choices_C_Maybe x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP__case_13 x1 x3 z x3500) x1002
     (Curry_Prelude.Guard_C_Maybe x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP__case_13 x1 x3 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_C_Maybe x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_OP__case_13 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> Curry_Prelude.C_Int -> Curry_Prelude.C_Maybe Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP__case_13 x1 x3 x5 x3000 x3500 = case x5 of
     (Curry_Prelude.C_Just x4) -> wrapDX id (Curry_ErrorState.d_C_returnES (Curry_Prelude.OP_Tuple2 x1 x4))
     Curry_Prelude.C_Nothing -> let
          x2000 = x3000
           in (seq x2000 (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_nextTVar x2000 x3500) (wrapNX id (nd_OP_freshVariant_dot_rename_dot_120_dot___hash_lambda17 x3 x1)))))
     (Curry_Prelude.Choice_C_Maybe x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_OP__case_13 x1 x3 x1002 x3000 x3500) (nd_OP__case_13 x1 x3 x1003 x3000 x3500)
     (Curry_Prelude.Choices_C_Maybe x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_OP__case_13 x1 x3 z x3000 x3500) x1002
     (Curry_Prelude.Guard_C_Maybe x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_OP__case_13 x1 x3 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_C_Maybe x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP__case_14 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.C_Maybe Curry_FlatCurry.C_TypeExpr -> ConstStore -> Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)))
d_OP__case_14 x1 x3 x7 x3500 = case x7 of
     Curry_Prelude.C_Nothing -> Curry_Prelude.d_OP_dollar (acceptCs id Curry_ErrorState.d_C_failES) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'U'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'k'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'w'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'f'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 's'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ':'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List))))))))))))))))))))))))))))))))) (Curry_Prelude.d_C_show x1 x3500) x3500) x3500
     (Curry_Prelude.C_Just x6) -> Curry_ErrorState.d_OP_gt_plus_eq (d_C_freshVariant x6 x3500) (d_OP_getTypeVariant_dot___hash_lambda13_dot___hash_lambda15 x1)
     (Curry_Prelude.Choice_C_Maybe x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP__case_14 x1 x3 x1002 x3500) (d_OP__case_14 x1 x3 x1003 x3500)
     (Curry_Prelude.Choices_C_Maybe x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP__case_14 x1 x3 z x3500) x1002
     (Curry_Prelude.Guard_C_Maybe x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP__case_14 x1 x3 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_C_Maybe x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_OP__case_14 :: Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.C_Maybe Curry_FlatCurry.C_TypeExpr -> IDSupply -> ConstStore -> Func (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr)) (Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) (Curry_Prelude.OP_Tuple3 (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) Curry_Prelude.C_Int (Curry_FiniteMap.C_FM Curry_Prelude.C_Int Curry_FlatCurry.C_TypeExpr))))
nd_OP__case_14 x1 x3 x7 x3000 x3500 = case x7 of
     Curry_Prelude.C_Nothing -> let
          x2000 = x3000
           in (seq x2000 (Curry_Prelude.nd_OP_dollar (wrapDX (wrapDX id) (acceptCs id Curry_ErrorState.d_C_failES)) (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'U'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'k'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'w'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'f'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 's'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ':'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List))))))))))))))))))))))))))))))))) (Curry_Prelude.d_C_show x1 x3500) x3500) x2000 x3500))
     (Curry_Prelude.C_Just x6) -> let
          x2000 = x3000
           in (seq x2000 (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_freshVariant x6 x2000 x3500) (wrapNX id (nd_OP_getTypeVariant_dot___hash_lambda13_dot___hash_lambda15 x1)))))
     (Curry_Prelude.Choice_C_Maybe x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_OP__case_14 x1 x3 x1002 x3000 x3500) (nd_OP__case_14 x1 x3 x1003 x3000 x3500)
     (Curry_Prelude.Choices_C_Maybe x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_OP__case_14 x1 x3 z x3000 x3500) x1002
     (Curry_Prelude.Guard_C_Maybe x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_OP__case_14 x1 x3 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_C_Maybe x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP__case_16 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.C_Maybe Curry_FlatCurry.C_Prog -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_FlatCurry.C_Prog)
d_OP__case_16 x1 x3 x4 x6 x3500 = case x6 of
     Curry_Prelude.C_Nothing -> Curry_Prelude.C_Left (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'g'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'T'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'y'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'p'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'E'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'v'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'F'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'r'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'm'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ':'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'C'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'f'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'm'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'd'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'l'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'e'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) Curry_Prelude.OP_List)))))))))))))))))))))))))))))))))))))) x3 x3500)
     (Curry_Prelude.C_Just x5) -> d_OP__case_15 x4 x1 x5 (d_OP_getTypeEnvFromProgEnv_dot_extract_dot_47 x1 x4 x3500) x3500
     (Curry_Prelude.Choice_C_Maybe x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP__case_16 x1 x3 x4 x1002 x3500) (d_OP__case_16 x1 x3 x4 x1003 x3500)
     (Curry_Prelude.Choices_C_Maybe x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP__case_16 x1 x3 x4 z x3500) x1002
     (Curry_Prelude.Guard_C_Maybe x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP__case_16 x1 x3 x4 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_C_Maybe x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP__case_15 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Curry_FlatCurry.C_Prog -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_FlatCurry.C_Prog) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_FlatCurry.C_Prog)
d_OP__case_15 x4 x1 x5 x8 x3500 = case x8 of
     (Curry_Prelude.C_Left x6) -> Curry_Prelude.C_Left x6
     (Curry_Prelude.C_Right x7) -> Curry_Prelude.C_Right (Curry_Prelude.OP_Cons x5 x7)
     (Curry_Prelude.Choice_C_Either x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP__case_15 x4 x1 x5 x1002 x3500) (d_OP__case_15 x4 x1 x5 x1003 x3500)
     (Curry_Prelude.Choices_C_Either x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP__case_15 x4 x1 x5 z x3500) x1002
     (Curry_Prelude.Guard_C_Either x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP__case_15 x4 x1 x5 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_C_Either x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP__case_17 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Curry_FlatCurry.C_Prog -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_FlatCurry.C_Prog) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr)
d_OP__case_17 x4 x1 x2 x10 x3500 = case x10 of
     (Curry_Prelude.C_Left x8) -> Curry_Prelude.C_Left x8
     (Curry_Prelude.C_Right x9) -> Curry_Prelude.C_Right (d_C_extractKnownTypes (Curry_Prelude.OP_Cons x2 x9) x3500)
     (Curry_Prelude.Choice_C_Either x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP__case_17 x4 x1 x2 x1002 x3500) (d_OP__case_17 x4 x1 x2 x1003 x3500)
     (Curry_Prelude.Choices_C_Either x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP__case_17 x4 x1 x2 z x3500) x1002
     (Curry_Prelude.Guard_C_Either x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP__case_17 x4 x1 x2 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_C_Either x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_OP__case_17 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Curry_FlatCurry.C_Prog -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_FlatCurry.C_Prog) -> IDSupply -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr)
nd_OP__case_17 x4 x1 x2 x10 x3000 x3500 = case x10 of
     (Curry_Prelude.C_Left x8) -> Curry_Prelude.C_Left x8
     (Curry_Prelude.C_Right x9) -> let
          x2000 = x3000
           in (seq x2000 (Curry_Prelude.C_Right (nd_C_extractKnownTypes (Curry_Prelude.OP_Cons x2 x9) x2000 x3500)))
     (Curry_Prelude.Choice_C_Either x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_OP__case_17 x4 x1 x2 x1002 x3000 x3500) (nd_OP__case_17 x4 x1 x2 x1003 x3000 x3500)
     (Curry_Prelude.Choices_C_Either x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_OP__case_17 x4 x1 x2 z x3000 x3500) x1002
     (Curry_Prelude.Guard_C_Either x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_OP__case_17 x4 x1 x2 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_C_Either x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP__case_18 :: Curry_Prelude.OP_List Curry_FlatCurry.C_FuncDecl -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.C_Maybe Curry_FlatCurry.C_FuncDecl -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr)
d_OP__case_18 x7 x2 x1 x10 x3500 = case x10 of
     Curry_Prelude.C_Nothing -> Curry_Prelude.C_Left (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'N'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 's'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'f'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) Curry_Prelude.OP_List))))))))))))))))
     (Curry_Prelude.C_Just x9) -> Curry_ErrorState.d_C_evalES (Curry_ErrorState.d_OP_gt_plus_eq (d_C_annFunc x9 x3500) d_C_inferFunc) (d_C_initTIM x1 x3500) x3500
     (Curry_Prelude.Choice_C_Maybe x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP__case_18 x7 x2 x1 x1002 x3500) (d_OP__case_18 x7 x2 x1 x1003 x3500)
     (Curry_Prelude.Choices_C_Maybe x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP__case_18 x7 x2 x1 z x3500) x1002
     (Curry_Prelude.Guard_C_Maybe x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP__case_18 x7 x2 x1 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_C_Maybe x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_OP__case_18 :: Curry_Prelude.OP_List Curry_FlatCurry.C_FuncDecl -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr -> Curry_Prelude.C_Maybe Curry_FlatCurry.C_FuncDecl -> IDSupply -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AFuncDecl Curry_FlatCurry.C_TypeExpr)
nd_OP__case_18 x7 x2 x1 x10 x3000 x3500 = case x10 of
     Curry_Prelude.C_Nothing -> Curry_Prelude.C_Left (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'N'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 's'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'h'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char ' '#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'f'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'u'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'c'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 't'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'i'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'o'#) (Curry_Prelude.OP_Cons (Curry_Prelude.C_Char 'n'#) Curry_Prelude.OP_List))))))))))))))))
     (Curry_Prelude.C_Just x9) -> let
          x2003 = x3000
           in (seq x2003 (let
               x2002 = leftSupply x2003
               x2004 = rightSupply x2003
                in (seq x2002 (seq x2004 (let
                    x2000 = leftSupply x2004
                    x2001 = rightSupply x2004
                     in (seq x2000 (seq x2001 (Curry_ErrorState.nd_C_evalES (wrapNX id (Curry_ErrorState.nd_OP_gt_plus_eq (nd_C_annFunc x9 x2000 x3500) (wrapNX id nd_C_inferFunc))) (nd_C_initTIM x1 x2001 x3500) x2002 x3500))))))))
     (Curry_Prelude.Choice_C_Maybe x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_OP__case_18 x7 x2 x1 x1002 x3000 x3500) (nd_OP__case_18 x7 x2 x1 x1003 x3000 x3500)
     (Curry_Prelude.Choices_C_Maybe x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_OP__case_18 x7 x2 x1 z x3000 x3500) x1002
     (Curry_Prelude.Guard_C_Maybe x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_OP__case_18 x7 x2 x1 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_C_Maybe x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

d_OP__case_19 :: Curry_FlatCurry.C_Prog -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr)
d_OP__case_19 x2 x1 x5 x3500 = case x5 of
     (Curry_Prelude.C_Left x3) -> Curry_Prelude.C_Left x3
     (Curry_Prelude.C_Right x4) -> d_C_inferProgEnv x4 x2 x3500
     (Curry_Prelude.Choice_C_Either x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (d_OP__case_19 x2 x1 x1002 x3500) (d_OP__case_19 x2 x1 x1003 x3500)
     (Curry_Prelude.Choices_C_Either x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> d_OP__case_19 x2 x1 z x3500) x1002
     (Curry_Prelude.Guard_C_Either x1000 x1001 x1002) -> guardCons x1000 x1001 ((d_OP__case_19 x2 x1 x1002) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_C_Either x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo

nd_OP__case_19 :: Curry_FlatCurry.C_Prog -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) Curry_FlatCurry.C_Prog) -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_FiniteMap.C_FM (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) Curry_FlatCurry.C_TypeExpr) -> IDSupply -> ConstStore -> Curry_Prelude.C_Either (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_AnnotatedFlatCurry.C_AProg Curry_FlatCurry.C_TypeExpr)
nd_OP__case_19 x2 x1 x5 x3000 x3500 = case x5 of
     (Curry_Prelude.C_Left x3) -> Curry_Prelude.C_Left x3
     (Curry_Prelude.C_Right x4) -> let
          x2000 = x3000
           in (seq x2000 (nd_C_inferProgEnv x4 x2 x2000 x3500))
     (Curry_Prelude.Choice_C_Either x1000 x1001 x1002 x1003) -> narrow x1000 x1001 (nd_OP__case_19 x2 x1 x1002 x3000 x3500) (nd_OP__case_19 x2 x1 x1003 x3000 x3500)
     (Curry_Prelude.Choices_C_Either x1000 x1001 x1002) -> narrows x3500 x1000 x1001 (\z -> nd_OP__case_19 x2 x1 z x3000 x3500) x1002
     (Curry_Prelude.Guard_C_Either x1000 x1001 x1002) -> guardCons x1000 x1001 ((nd_OP__case_19 x2 x1 x1002 x3000) $! (addCs x1001 x3500))
     (Curry_Prelude.Fail_C_Either x1000 x1001) -> failCons x1000 x1001
     _ -> failCons defCover defFailInfo
